unit facstruc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math;

procedure calcul_diagramme(var ier:integer);

implementation

uses
  mathhkl,fstruc;

var
  s_pos               : array[1..192] of string[25];
  npos0               : integer;

// Calcul de la multiplicit d'un site du motif asymtrique
procedure calcul_multiplicite_site;{
-----------------------------------}
var
  i,j,k,n             : integer;
  xx,yy,zz            : double;
  x,y,z               : array[1..1000] of double;
  ind                 : array[1..1000] of integer;
  //nomf:TextFile;
begin
  mult_max:=0;
  for i:=1 to nb_atome do begin
  //Gnration du contenu de la maille
    n:=0;
    for j:=1 to npos do begin
      xx:=tp[j,1,4]+x_at[i]*tp[j,1,1]+y_at[i]*tp[j,1,2]+z_at[i]*tp[j,1,3];
      yy:=tp[j,2,4]+x_at[i]*tp[j,2,1]+y_at[i]*tp[j,2,2]+z_at[i]*tp[j,2,3];
      zz:=tp[j,3,4]+x_at[i]*tp[j,3,1]+y_at[i]*tp[j,3,2]+z_at[i]*tp[j,3,3];
      if (xx < 0) then xx:=xx+10;
      if (yy < 0) then yy:=yy+10;
      if (zz < 0) then zz:=zz+10;
      xx:=frac(xx);
      yy:=frac(yy);
      zz:=frac(zz);
      n:=n+1;
      x[n]:=xx;
      y[n]:=yy;
      z[n]:=zz;
      ind[n]:=1;
      if (icent = 1)then begin
        xx:=-xx;
        yy:=-yy;
        zz:=-zz;
        if (xx < 0) then xx:=xx+10;
        if (yy < 0) then yy:=yy+10;
        if (zz < 0) then zz:=zz+10;
        xx:=frac(xx);
        yy:=frac(yy);
        zz:=frac(zz);
        n:=n+1;
        x[n]:=xx;
        y[n]:=yy;
        z[n]:=zz;
        ind[n]:=1;
      end;
    end;

    //Elimination des superpositions
    if(n > 1)then begin
      for j:=1 to n-1 do begin
        for k:=j+1 to n do begin
           if(ind[k] = 0)then continue;
           if(abs(x[j]-x[k]) > 0.001)then continue;
           if(abs(y[j]-y[k]) > 0.001)then continue;
           if(abs(z[j]-z[k]) > 0.001)then continue;
           ind[k]:=0;
        end;
      end;
    end;

    //Calcul de la multiplicit
    mult[i]:=0;
    for j:=1 to n do begin
      if (ind[j] = 0)then continue;
      mult[i]:=mult[i]+1;
    end;

    mult[i]:=abs(mult[i]*pop[i]);
    if(mult[i] > mult_max)then mult_max:=mult[i];

  end;
  for i:=1 to nb_atome do  mult[i]:=mult[i]/mult_max;
  if (icent = 0) then   contenu_maille:=mult_max/npos
  else  contenu_maille:=0.5*mult_max/npos;

end;

procedure calcul_diagramme(var ier:integer);
//-----------------------------------------
var
  s                                : string;
  i,j,k                            : integer;
  fp                               : double;

begin

//-------------------------------Dbut criture---------------------------------
if (nb_tour = 1)then begin
//------------------------------------------------------------------------------
  case type_source of
    1: begin
        if (type_lp = 0)then begin
         writeln(nom_fic1,
'POUDRIX. Powder diffraction diagram (Source: X ray tube)');
         writeln(nom_fic1,
'--------------------------------------------------------');
        end else begin
          writeln(nom_fic1,
'POUDRIX. Powder diffraction diagram (Source: Synchrotron)');
  writeln(nom_fic1,
'---------------------------------------------------------');
          writeln(nom_fic1);
          writeln(nom_fic1,'Polarisation p=',probabilite:7:2);
        end;
      end;
    2:begin
       writeln(nom_fic1,
' POUDRIX : Powder diffraction diagram (Source: Neutrons)');
  writeln(nom_fic1,
' -------------------------------------------------------');
      end;
  end;
  writeln(nom_fic1);
  s:=DateTimeToStr(Now);
  Writeln(nom_fic1,s);
  Writeln(nom_fic1,titre);
  writeln(nom_fic1,'Cell   : ',cel[1]:8:3,cel[2]:8:3,cel[3]:8:3,
  cel[4]:8:3,cel[5]:8:3,cel[6]:8:3);
  writeln(nom_fic1,'Lambda : ',lambda_calc:10:5);
  writeln(nom_fic1,'S.Group: ',groupe_espace);
  writeln(nom_fic1,'Syst.  : ',systeme);
  writeln(nom_fic1,'Bravais: ',bravais);

  // Recherche du groupe d'espace dans le fichier .POS et dcodage
  if centre then writeln(nom_fic1,'Centro')
  else writeln(nom_fic1,'Non Centro');

  //Oprateurs de symtrie
  writeln(nom_fic1);
  writeln(nom_fic1,'Space group positions:');
  for i:=1 to npos0 do writeln(nom_fic1,s_pos[i]);
  // Translations du rseau
  //set_translations;
  if (nb_translation > 1)then begin
    writeln(nom_fic1);
    writeln(nom_fic1,'Bravais lattice translations:');
    for i:=1 to nb_translation
    do writeln(nom_fic1,tx[i]:10:6,ty[i]:10:6,tz[i]:10:6);
  end;


   //Calcul de la multiplicit de chaque site valable uniquement pour les poudres;

//---------------------------------------------------------------
  calcul_multiplicite_site;
//---------------------------------------------------------------

  writeln(nom_fic1);
  writeln
  (nom_fic1,'Asymetric unit content:');

  if (type_source = 2)then begin
    writeln(nom_fic1,
    '       x        y        z      B      Pop.   Mult.   Fermi');
    j:=nb_atome;
//    if (icent=1) then j:=nb_atome div 2 ;
    for i:=1 to j do
    writeln(nom_fic1,atome[i]:2,labell[i]:2,x_at[i]:9:5,y_at[i]:9:5,z_at[i]:9:5,
    btherm[i]:6:2,pop[i]:8:3,mult[i]:8:3,b_fermi[i]:8:3);
    writeln(nom_fic1);
  end else begin
     writeln(nom_fic1,
    '         x        y        z      B      Pop.   Mult. Elem. Nb.');
    j:=nb_atome;
//    if (icent=1) then j:=nb_atome div 2 ;
    for i:=1 to j do
    writeln(nom_fic1,atome[i]:2,labell[i]:2,x_at[i]:9:5,y_at[i]:9:5,z_at[i]:9:5,
    btherm[i]:6:2,pop[i]:8:3,mult[i]:8:3,no_atome[i]:5);
    writeln(nom_fic1);

    writeln(nom_fic1,'Atomic scattering factors ');
    write(nom_fic1,'      f(0)');
    for k:=1 to nb_wl_impur do write(nom_fic1,'        f''        f"');
    writeln(nom_fic1);
    for i:=1 to nb_element do begin
      fp:=cf[i];
      for k:=1 to 4 do fp:=fp+af[i,k];
      write(nom_fic1,element[i],fp:10:4);
      for k:=1 to nb_wl_impur do write(nom_fic1,delfr[k,i]:10:4,delfi[k,i]:10:4);
      writeln(nom_fic1);
    end;
    writeln(nom_fic1);
    writeln(nom_fic1,'Cromer Factors');
    writeln(nom_fic1,
    '       c       a1     b1       a2      b2      a3      b3      a4      b4');
    for i :=1 to nb_element do begin
      write(nom_fic1,element[i]);
      write(nom_fic1,cf[i]:8:4);
      for j:=1 to 4 do write(nom_fic1,af[i,j]:8:4,bf[i,j]:8:4);
      writeln(nom_fic1);
    end;
  end;
//-----------------------------------------------------------------------------
end;
//---------------------------------fin criture--------------------------------
case type_source of

//---------------------------------------------------------------
   1: generX;
   2: generN;
//---------------------------------------------------------------

end;

end;
end.
