unit fichiers;

interface
uses
  Windows, Messages, SysUtils  ;

procedure lit_fichier_raw(num : integer;var ier:integer);
procedure lit_fichier_raw2;
procedure liraw_rietveld(var ier : integer);

implementation

uses
  mathhkl,main,lilambda,plecran;

//=============================================================================
procedure liraw_bruker(var ier:integer);{
----------------------------------------}
var
  nb_total_bytes,step_count          : integer;
  dtheta_depart,step_size            : double;
  xmin,xmax                          : double;

  i,longueur_header                  : integer;
  i2                                 : smallint;
  i4                                 : longint;
  c4                                 : array[1..4] of char;
  c32                                : array[1..32] of char;
  c                                  : char;
  x,y                                : single;
  x8,wl,wl1,wl2,ratio,stp_si,th_dep  : double;
  s                                  : string;
  nomf                               : file;
  ech                                : double;

begin
  ier:=0;
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;
  titre_raw:='';

  assignFile(nomf,nom_fichier_raw);
  reset(nomf,1);
  {Fichier RAW ou RAW2?}
  blockread(nomf,c4,4);
  s:='';
  for i:=1 to 4 do begin
    s[i]:=c4[i];
  end;

  {--------------------Lecture de fichier type RAW2----------------------------}
  s:=trimright(s);
  if (s = 'RAW2')then begin
    {nb. de tranches}
    blockread(nomf,i,4);                                       //offset 8
    //Sample name
    blockread(nomf,c32,32);                                    //      40
    s:='*';
    for i:=1 to 32 do s:=s+'*';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW2)';
    for i:=1 to 148 do blockread(nomf,c,1);                    //offset 188
    blockread(nomf,c4,2);                                      //offset 190
    anode_raw:='**';
    for i:=1 to 2 do anode_raw[i]:=c4[i];
    {lambda1}
    blockread(nomf,x,4);
    lambda1_raw:=x;
    {Lambda2}
    blockread(nomf,x,4);
    lambda2_raw:=x;
    {Ratio lambda2/lambda1}
    blockread(nomf,x,4);                                      //offset 202
    ratio_raw:=x;
    if (lambda_raw = 0) and (lambda2_raw > 0)then
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw) else
    lambda_raw:=lambda1_raw;
    for i:=1 to 54 do blockread(nomf,c,1);
    {dimension header}
    blockread(nomf,i2,2);
    nb_total_bytes:=i2;
    {step_count}
    blockread(nomf,i2,2);
    step_count:=i2;
    for i:=1 to 8 do blockread(nomf,c,1);
    {step_size}
    blockread(nomf,x,4);
    step_size:=x;
    {2thta dpart}
    blockread(nomf,x,4);
    dtheta_depart:=x;
    for i:=1 to 40 do blockread(nomf,c,1);
    {enregistrements supplmentaires}
    if (nb_total_bytes > 60)then begin
      for i:=1 to nb_total_bytes-60 do blockread(nomf,c,1);
    end;
    {profil}
    ymax:=0;
    ymin:=1000000;
    nb_raie_raw:=step_count;
    xmax:=0;
    xmin:=180;
    for i:=1 to step_count do begin
      blockread(nomf,y,4);
      x:=dtheta_depart+(i-1)*step_size;
      x_raw[i]:=x;
      y_raw[i]:=y;
      if (xmax < x)then xmax:=x;
      if (xmin > x)then xmin:=x;
      if(ymax < y)then ymax:=y;
      if(ymin > y)then ymin:=y;
    end;
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
  //end;

{---------------------Lecture de fichier type RAW------------------------------}
  end else if (s = 'RAW') then begin        //Ne donne ni lambda moy ni anode
    anode_raw:='?';
    {step_count}
    blockread(nomf,i4,4);                            //8
    step_count:=i4;
    for i:=1 to 4 do blockread(nomf,c,1);            //offset 12
    {step_size}
    blockread(nomf,x,4);                             //16
    step_size:=x;
    for i:=1 to 8 do blockread(nomf,c,1);            //24
    {dtheta_depart}
    blockread(nomf,x,4);                             //28
    dtheta_depart:=x;
    for i:=1 to 12 do blockread(nomf,c,1);           //40

    //titre echantillon
    blockread(nomf,c32,32);                          //72
    s:='*';for i:=1 to 32 do s:=s+'*';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW)';

    {Lecture lambda}
    blockread(nomf,x,4);                              //76
    lambda1_raw:=x;
    {lambda2}
    blockread(nomf,x,4);                              //80
    lambda2_raw:=x;
    if (lambda_raw = 0) and (lambda2_raw > 0)then
    lambda_raw:=(lambda1_raw+0.50*lambda2_raw)/1.5
    else lambda_raw:=lambda1_raw;
    for i:=1 to 72 do blockread(nomf,c,1);
    {Nb. de tranches supplmentaires}
    blockread(nomf,i4,4);
    {profil}
    nb_raie_raw:=step_count;
    ymax:=0;
    ymin:=1000000;
    xmax:=0;
    xmin:=180;
    for i:=1 to step_count do begin
      blockread(nomf,y,4);
      x:=dtheta_depart+(i-1)*step_size;
      if (xmax < x)then xmax:=x;
      if (xmin > x)then xmin:=x;
      if(y > ymax)then ymax:=y;
      if(y < ymin)then ymin:=y;
      x_raw[i]:=x;
      y_raw[i]:=y;
    end;
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
    if (lambda_raw = 0) and (lambda2_raw > 0)then
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw)
    else lambda_raw:=lambda1_raw;
  //end;

  end else if (s = 'RAW1')then begin      // donne lambda moy anode ratio
    for i:=1 to 326 do blockread(nomf,c,1);        //offset 326
    blockread(nomf,c32,32);                        //       358
    s:='********************************';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW1)';
    for i:=1 to 246 do blockread(nomf,c,1);         //       604
    blockread(nomf,c4,4);                          //Offset 612
    anode_raw:='**';
    for i:=1 to 2 do anode_raw[i]:=c4[i];
    blockread(nomf,c4,4);                          //Offset 616
    blockread(nomf,wl,8);                          //offset 624
    blockread(nomf,wl1,8);                         //offset 632
    blockread(nomf,wl2,8);                         //offset 640
    blockread(nomf,x8,8);                          //offset 648
    blockread(nomf,ratio,8);                       //offset 656
    for i:=1 to 56 do blockread(nomf,c,1);         //offset 712 fin du 1er header

    for i:=1 to 4 do blockread(nomf,c,1);
    blockread(nomf,i4,4);                         // offset 8
    nb_raie_raw:=i4;
    for i:=1 to 8 do blockread(nomf,c,1);         // offset 16
    blockread(nomf,th_dep,8);                     // offset 24
    for i:=1 to 152 do blockread(nomf,c,1);       //offset 176
    blockread(nomf,stp_si,8);                     //offset 184
    for i:=1 to 72 do blockread(nomf,c,1);        //offset 256
    blockread(nomf,i4,4);                         // offset260
    longueur_header:=i4;
    for i:=1 to 44 do blockread(nomf,c,1);        //offset 304

    if (longueur_header > 0)then                 //Enregistrements supplmentaires
    for i:=1 to longueur_header do blockread(nomf,c,1);

    ymax:=-10000;
    ymin:=1000000;
    nb_raie_raw:=0;
    //For i:=1 to nb_raie_raw do begin
    while not eof(nomf) do begin
      nb_raie_raw:=nb_raie_raw+1;
      x_raw[nb_raie_raw]:=th_dep+(nb_raie_raw-1)*stp_si;
      blockread(nomf, y_raw[nb_raie_raw],4);
      if (ymax < y_raw[nb_raie_raw])then ymax:=y_raw[nb_raie_raw];
      if (ymin > y_raw[nb_raie_raw])then ymin:=y_raw[nb_raie_raw];
    end;
    lambda1_raw:=wl1;
    lambda2_raw:=wl2;
    lambda_raw:=wl;
    theta_min_raw:=x_raw[1];
    theta_max_raw:=x_raw[nb_raie_raw];
  end else begin
    erreur('Unknown file type');
    closefile(nomf);
    ier:=1;
    exit;
  end;

  closefile(nomf);
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin;
  for i:=1 to nb_raie_raw do y_raw[i]:=(y_raw[i]-ymin)*ech;
  chdir(repertoire_origine);
end;

//Lecture fichiers Rietveld (*.dat)
procedure liraw_rietveld(var ier:integer);
//---------------------------------------
var
  i,j,n                    : integer;
  xmin,xmax,x,pas,ech      : double;
  nomf                     : TextFile;
  s,s1                     : string;
  ligne                    : tab_dec;
  nb                       : integer;
  label 1;
begin
  ier:=0;
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;

  assignFile(nomf,nom_fichier_raw);
  reset(nomf);

  //Lecture du header
 (* readln(nomf,s);
   if (s = '')then begin
    readln(nomf);
    readln(nomf);
    readln(nomf);
    goto 1
  end;
  if (pos('SampleIdent',s) = 0)then begin
    erreur('Error while reading the wavelength in Rietvelf File');
    closeFile(nomf);
    ier:=1;
    exit;
  end else begin
    i:=pos('SampleIdent',s)+12;
    j:=pos('DataFileName',s);
    titre_raw:=copy(s,i,j-i-1);
    titre_raw:=trim(titre_raw);
  end;
  readln(nomf);
  readln(nomf,s);
  n:=pos('Alpha1',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha1'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda1_raw:=x else lambda1_raw:=0;
  end;
  n:=pos('Alpha2',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha2'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda2_raw:=x else lambda2_raw:=0;
  end;
  n:=pos('Ratio',s);
  if (n > 0)then begin
    delete(s,1,n+length('Ratio'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then ratio_raw:=x else ratio_raw:=0;
  end;
  lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);
  n:=pos('Alpha2',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha1'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda2_raw:=x else lambda2_raw:=0;
  end;
  readln(nomf); *)
  //Lecture du header
  readln(nomf,s);
  if (s = '')then begin
    readln(nomf);
    readln(nomf);
    readln(nomf);
    goto 1
  end;
  if (pos('SampleIdent',s) = 0)then begin
    erreur('Error while reading the wavelength in Rietvelf File');
    closeFile(nomf);
    exit;
  end else begin
    i:=pos('SampleIdent',s)+12;
    j:=pos('DataFileName',s);
    titre_raw:=copy(s,i,j-i-1);
    titre_raw:=trim(titre_raw);
  end;
  readln(nomf);
  readln(nomf,s);
  n:=pos('Alpha1',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha1'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda1_raw:=x else lambda1_raw:=0;
  end;
  n:=pos('Alpha2',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha2'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda2_raw:=x else lambda2_raw:=0;
  end;
  n:=pos('Ratio',s);
  if (n > 0)then begin
    delete(s,1,n+length('Ratio'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then ratio_raw:=x else ratio_raw:=0;
  end;
  lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);
  n:=pos('Alpha2',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha1'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda2_raw:=x else lambda2_raw:=0;
  end;
  readln(nomf);

 //Lecture theta_min, pas, theta_max
1:  readln(nomf,xmin,pas,xmax);
  n:=0;
  ymax:=0;
  ymin:=1000000;
  while not(eof(nomf)) do begin
    readln(nomf,s);
    dec(s,ligne,nb,ier);
    if (ier > 0)then begin
      erreur('Read error!');
      ier:=1;
      exit;
    end;
    for i:=1 to nb do begin
      n:=n+1;
      y_raw[n]:=ligne[i];
      x_raw[n]:=xmin+(n-1)*pas;
      if (y_raw[n] > ymax)then ymax:=y_raw[n];
      if (y_raw[n] < ymin)then ymin:=y_raw[n];
    end;
  end;
  nb_raie_raw:=n;
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin;
  for i:=1 to nb_raie_raw do y_raw[i]:=(y_raw[i]-ymin)*ech;
  theta_min_raw:=xmin;
  theta_max_raw:=xmax;
  closefile(nomf);
  chdir(repertoire_origine);
end;

procedure liraw_cpi(var ier:integer);
//----------------------------------
var
  i,n                      : integer;
  xmin,xmax,x,pas,ech      : double;
  nomf                     : TextFile;
  s                        : string;
begin
  ier:=0;
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;
  xmax:=180;
  xmin:=0;

  assignFile(nomf,nom_fichier_raw);
  reset(nomf);
  readln(nomf,titre);
  readln(nomf,xmin);
  read(nomf,xmax);
  readln(nomf,pas);
  readln(nomf,anode_raw);
  readln(nomf,lambda_raw);
  readln(nomf,s);                       //date
  readln(nomf,s);                       // '1'
  readln(nomf,s);
  titre_raw:=copy(s,12,length(s)-12);   //Sample Ident
  titre_raw:=trim(titre_raw);
  readln(nomf);                         //ScanData
  ymax:=0;
  ymin:=1000000;
  n:=0;
  while not(eof(nomf)) do begin
    read(nomf,x);
    n:=n+1;
    y_raw[n]:=x;
    if (x > ymax)then ymax:=x;
    if (x < ymin)then ymin:=x;
    x_raw[n]:=xmin+(n-1)*pas;
  end;
  nb_raie_raw:=n;
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin ;
  for i:=1 to n do y_raw[i]:=(y_raw[i]-ymin)*ech;
  closefile(nomf);
  theta_min_raw:=xmin;
  theta_max_raw:=xmax;
  chdir(repertoire_origine);
end;

//Lecture de fichier profil philips (*.rd)
procedure liraw_philips(var ier:integer);
//--------------------------------------
var
  i                                  : integer;
  i2                                 : smallint;
  c2                                 : array[1..2]of char;
  c60                                : array[1..60] of char;
  c                                  : char;

  by                                 : byte;
  doub                               : double;
  xmin,xmax,pas,ech                  : double;
  nomf                               : file;
  version                            : string[2];
  s                                  : string;
begin
  ier:=0;
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;

  assignFile(nomf,nom_fichier_raw);
  reset(nomf,1);
  {Revision No}
  blockread(nomf,c2,2);                                  //offset=2
  s:='';
  for i:=1 to 2 do begin
    s[i]:=c2[i];
  end;
  version:=s;
  //Type of data file
  blockread(nomf,c2,2);                                   //offset=4
  s:='';
  for i:=1 to 2 do s[i]:=c2[i];
  if (s <> 'RD')then begin
    erreur('It seems not to be a .RD Philips file');
    ier:=1;
    exit;
  end;
      for i:=1 to 81 do blockread(nomf,c,1);               //offset=85
      blockread(nomf,by,1);                               //offset=86
      case by of
        0: anode_raw:='Cu';
        1: anode_raw:='Mo';
        2: anode_raw:='Co';
        3: anode_raw:='Fe';
        4: anode_raw:='Cr';
      end;
      for i:=1 to 8 do blockread(nomf,c,1);               //offset=94
      //lambda1
      blockread(nomf,doub,8);                             //offset=102
      lambda1_raw:=doub;
      //lambda2
      blockread(nomf,doub,8);                             //offset=110
      lambda2_raw:=doub;
      //Ratio
      blockread(nomf,doub,8);                             //offset=118

      //sample identification
      for i:=1 to 28 do blockread(nomf,c,1);               //      146
      s:='*';
      for i:=1 to 20 do s:=s+'*';
      blockread(nomf,c60,20);                              //      166
      for i:=1 to 20 do s[i]:=c60[i];
      titre_raw:=trim(s);

      ratio_raw:=doub;
      for i:=1 to 48 do blockread(nomf,c,1);               //offset 214
     //StepSize
      blockread(nomf,doub,8);                              //offset=222
      pas:=doub;
      //Start angle
      blockread(nomf,doub,8);                               //offset=230
      xmin:=doub;
      //Final angle
      blockread(nomf,doub,8);                              //offset=238
      xmax:=doub;
      if (version = 'V5')then for i:=1 to 572 do blockread(nomf,c,1)
      else for i:=1 to 12 do blockread(nomf,c,1);          //offset=250 ou 810
      nb_raie_raw:=round((xmax-xmin)/pas)+1;
      ymax:=0;
      ymin:=1000000;
      for i:=1 to nb_raie_raw do begin
        x_raw[i]:=xmin+(i-1)*pas;
        blockread(nomf,i2,2);
        y_raw[i]:=sqr(i2*0.1);
        if (ymax < y_raw[i])then ymax:=y_raw[i];
        if (ymin > y_raw[i])then ymin:=y_raw[i];
      end;
    CloseFile(nomf);
    ech:=100/(ymax-ymin);
    ymax_raw:=ymax;
    ymin_raw:=ymin;
    for i:=1 to nb_raie_raw do y_raw[i]:=(y_raw[i]-ymin)*ech;
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
    chdir(repertoire_origine);
end;

procedure lit_fichier_raw2;
//-------------------------
var
  i,j,nn,i1,i2                         : integer ;
  i0,kk                                : double;
  s,s1                                 : string;
begin
    nb_fichier_raw:=nb_fichier_raw+1;
    lambda_fichier_raw[nb_fichier_raw]:=lambda_raw;

    if (nb_wl_impur = 0) and (nb_fichier_raw = 1) then begin
      theta_min:=theta_min_raw;
      theta_max:=theta_max_raw;
      theta_min_depart:=theta_min_raw;
      theta_max_depart:=theta_max_raw;
      lambda:=lambda_raw;
      nb_wl_impur:=1;
      wl_impur[1]:=lambda;
      str(lambda:8:5,s);
      fmain.edit11.text:=s;
      lambda_max:=lambda;
      lambda_min:=lambda;
      q_min:=4*pi*sin(theta_min/114.5914)/lambda_max;
      q_max:=4*pi*sin(theta_max/114.5914)/lambda_min;
      q_min_depart:=q_min;
      q_max_depart:=q_max;
      disp_experiment;
    end else begin
      j:=1;
      if (nb_wl_impur > 0)then begin
        for i:=1 to nb_wl_impur do begin
          if (abs(wl_impur[i]-lambda_raw) < 0.05)then begin
            j:=0;
            break;
          end;
        end;
        if (j = 1)then begin
          str(wl_impur[1]:8:5,s1);
          str(lambda_raw:8:5,s);
          erreur
          ('Warning: The read wavelength ('+s+
          ') is different from the current one ('+s1+')');
        end;
      end;
    end;

    //Interpolation pour ramener nb_raie_raw points a nn points
    //Dtermination des premier et dernier point
    i1:=1;
    for i:=1 to nb_raie_raw do begin
      if (x_raw[i] >= theta_min)then begin
        i1:=i;
        break;
      end;
    end;
    i2:=nb_raie_raw;
    for i:=nb_raie_raw downto 1 do begin
      if (x_raw[i] <= theta_max)then begin
        i2:=i;
        break;
      end;
    end;
    nbraw_pro:=nbraw_pro+1;
    nom_raw[nbraw_pro]:=extractFilename(nom_fichier_raw);
    nn:=1015;
    i0:=(i1*nn-i2)/(nn-1);
    kk:=(i2-i1)/(nn-1);
    //assignfile(nomf,'espion');
    //rewrite(nomf);
    for i:=1 to nn do begin
      //j:=round(i0+kk*i);
      xraw_pro[nbraw_pro,i]:=0;
      yraw_pro[nbraw_pro,i]:=0;
      qraw_pro[nbraw_pro,i]:=0;
    end;
    for i:=1 to nn do begin
      j:=round(i0+kk*i);
      if (j < i1)then continue;
      if (j > i2)then break;
      xraw_pro[nbraw_pro,i]:=x_raw[j];
      yraw_pro[nbraw_pro,i]:=y_raw[j];
      qraw_pro[nbraw_pro,i]:=4*pi*sin(x_raw[j]/114.5916)/lambda_raw;
      //writeln(nomf,xx:8:3,yy:8:3,ix:10,iy:10);
    end;
    //dessine(sender);
    //closefile(nomf);
end;

procedure lit_fichier_raw(num : integer;var ier:integer);
//------------------------------------------------------
var
  nn,i1,i2                             : integer ;
  i0,kk                                : double;
  s,s1                                 : string;
  nomf                                 : textfile;
begin
  ier:=0;
  if(nb_pro = 0)and(nb_pron = 0)and(nbraw_pro = 0)then fplecran.height:=290;
  with fplecran do begin
    OpenDialog1.filterIndex:=num;
    if OpenDialog1.execute then begin
      nom_fichier_raw:=OpenDialog1.filename;
      if (length(nom_fichier_raw) = 0)then begin
        ier:=1;
        exit;
      end;
      case num of
        1:liraw_bruker(ier);
        2:liraw_philips(ier);
        3:liraw_bruker(ier);
        4:begin
            assignFile (nomf, nom_fichier_raw);
            reset(nomf);
            readln(nomf,s);
            if (s = '')then begin
               closefile(nomf);
               flilambda.visible:=true;
               exit;
            end;
            liraw_rietveld(ier);
          end;
        5:liraw_cpi(ier);
        6:liraw_cpi(ier);
      end;
    end else begin
      ier:=1;
      exit;
    end;
  end;
  if (ier = 0)then lit_fichier_raw2
end;

end.
