unit fstruc;

interface

uses
  SysUtils,math;
var
  mult_max     : double;

procedure generX;
procedure generN;

implementation

uses
  mathhkl;

type
  tab_int48  = array[1..192] of integer;
  tab_it     = array[1..96,1..3,1..3] of integer;
var
  norme        : double;
 procedure f( var no_element: integer; var sithl,fp,fs:double);
//----------------------------------------------------------
//Calcul du facteur de diffusion atomique pour l'atome no_element/SITHL
  var
     sithl2              : double;
     i                   : integer;
  begin
     sithl2:=sithl*sithl;
     fp:=cf[no_element]+delfr[nb_tour,no_element];
     for i:=1 to 4 do fp:=fp+af[no_element,i]*exp(-bf[no_element,i]*sithl2);
     fs:=delfi[nb_tour,no_element];
  end;

procedure fstrX(var h,k,l:integer;var sithl,a_plus,b_plus,a_moins,b_moins: double);
//------------------------------------------------------------------------------
//Calcul du facteur de structure
const
  depi : double=6.283185;
var
  t,xx,yy,zz,phase,aa,bb,fp,fs    : double;
  a_p,b_p,a_m,b_m                 : double;
  i,j                             : integer;
begin
  a_plus:=0;
  b_plus:=0;
  a_moins:=0;
  b_moins:=0;
  for j:=1 to nb_atome do begin
     f(no_atome[j],sithl,fp,fs);
     t:=exp(-btherm[j]*sithl*sithl)*mult[j];
     fp:=fp*t;
     fs:=fs*t;
     a_p:=0;
     b_p:=0;
     a_m:=0;
     b_m:=0;

     for i:=1 to npos do begin
       xx:=tp[i,1,4]+x_at[j]*tp[i,1,1]+y_at[j]*tp[i,1,2]+z_at[j]*tp[i,1,3];
       yy:=tp[i,2,4]+x_at[j]*tp[i,2,1]+y_at[j]*tp[i,2,2]+z_at[j]*tp[i,2,3];
       zz:=tp[i,3,4]+x_at[j]*tp[i,3,1]+y_at[j]*tp[i,3,2]+z_at[j]*tp[i,3,3];
       phase:=depi*(h*xx+k*yy+l*zz);
       aa:=cos(phase);
       bb:=sin(phase);
       a_p:=a_p    +  fp*aa-fs*bb;
       b_p:=b_p    +  fs*aa+fp*bb;
       a_m:=a_m    +  fp*aa+fs*bb;
       b_m:=b_m    +  fs*aa-fp*bb;
     end;
     a_plus:=a_plus+a_p;
     b_plus:=b_plus+b_p;
     a_moins:=a_moins+a_m;
     b_moins:=b_moins+b_m;
   end;
   a_plus:=contenu_maille*a_plus;
   b_plus:=contenu_maille*b_plus;
   a_moins:=contenu_maille*a_moins;
   b_moins:=contenu_maille*b_moins;

 end;

procedure fstrN(var h,k,l:integer;var sithl,a_plus,b_plus:double);
//-------------------------------------------------------------
//Calcul du facteur de structure
const
  depi : double=6.283185;
var
  t,xx,yy,zz,phase,aa,bb,fp       : double;
  a_p,b_p                         : double;
  i,j                             : integer;
begin
  a_plus:=0;
  b_plus:=0;
  for j:=1 to nb_atome do begin
    fp:=b_fermi[no_atome[j]];
    t:=exp(-btherm[j]*sithl*sithl)*mult[j];
    fp:=fp*t;
    a_p:=0;
    b_p:=0;
    for i:=1 to npos do begin
      xx:=tp[i,1,4]+x_at[j]*tp[i,1,1]+y_at[j]*tp[i,1,2]+z_at[j]*tp[i,1,3];
      yy:=tp[i,2,4]+x_at[j]*tp[i,2,1]+y_at[j]*tp[i,2,2]+z_at[j]*tp[i,2,3];
      zz:=tp[i,3,4]+x_at[j]*tp[i,3,1]+y_at[j]*tp[i,3,2]+z_at[j]*tp[i,3,3];
      phase:=depi*(h*xx+k*yy+l*zz);
      aa:=cos(phase);
      bb:=sin(phase);
      a_p:=a_p    +  fp*aa;
      b_p:=b_p    +  fp*bb;
    end;
    a_plus:=a_plus+a_p;
    b_plus:=b_plus+b_p;
  end;
   a_plus:=contenu_maille*a_plus;
   b_plus:=contenu_maille*b_plus;
end;

//Fvrier 2001 Version2
procedure extin2(var ih,ik,il,ibon:integer);
//-------------------------------------------
var
  depi,a,b,x,y,z,xx,yy,zz,phase   : double;
  j                               : integer;
begin
  a:=0;
  b:=0;
  depi:=2*pi;
  x:=0.13314161;y:=0.2121487;z:=0.6139476;
  for j:=1 to npos do begin
    xx:=tp[j,1,4]+x*tp[j,1,1]+y*tp[j,1,2]+z*tp[j,1,3];
    yy:=tp[j,2,4]+x*tp[j,2,1]+y*tp[j,2,2]+z*tp[j,2,3];
    zz:=tp[j,3,4]+x*tp[j,3,1]+y*tp[j,3,2]+z*tp[j,3,3];
      if (xx < 0) then xx:=xx+10;
      if (yy < 0) then yy:=yy+10;
      if (zz < 0) then zz:=zz+10;
      xx:=frac(xx);
      yy:=frac(yy);
      zz:=frac(zz);
      phase:=depi*(ih*xx+ik*yy+il*zz);
      a:=a+cos(phase);
      b:=b+sin(phase);
  end;

//Deuxime essai
  if ((a*a+b*b) < 0.001)then begin
    a:=0;b:=0;
    x:=0.43714161;y:=0.0121487;z:=0.618476;
    for j:=1 to npos do begin
      xx:=tp[j,1,4]+x*tp[j,1,1]+y*tp[j,1,2]+z*tp[j,1,3];
      yy:=tp[j,2,4]+x*tp[j,2,1]+y*tp[j,2,2]+z*tp[j,2,3];
      zz:=tp[j,3,4]+x*tp[j,3,1]+y*tp[j,3,2]+z*tp[j,3,3];
      if (xx < 0) then xx:=xx+10;
      if (yy < 0) then yy:=yy+10;
      if (zz < 0) then zz:=zz+10;
      xx:=frac(xx);
      yy:=frac(yy);
      zz:=frac(zz);
      phase:=depi*(ih*xx+ik*yy+il*zz);
      a:=a+cos(phase);
      b:=b+sin(phase);
    end;
    if ((a*a+b*b) < 0.001)then ibon:=1 else ibon:=0;
  end else ibon:=0;

end;

{Extinctions du rseau de Bravais + extinctions du groupe.
(ib:=0 : c'est bon)}
procedure extinc(var ih,ik,il: integer; var ib:integer);{
----------------------------------------------------}
var
  is1,is2,is3,isom1,i           : integer;
  ibon,ibrav                    : integer;
begin

  if(ih = 0) and (ik = 0) and (il = 0)then begin
    ib:=1;
    exit;
  end;
  ibrav:=ord(bravais[1]);
  if (systeme = 'HEXA') and (copy(groupe_espace,1,1) = 'R')then ibrav:=82;
  ib:=1;
  case ibrav of
   80:                                  {Primitif}
      ib:=0;
   73:                                  {Corps centr}
      if( ((ih+ik+il) mod 2) = 0) then ib:=0;
   70:                                  {Faces centres}
      begin
        is1:=ih+ik;
        is2:=ik+il;
        is3:=il+ih;
        isom1:=abs(is1 mod 2)+abs(is2 mod 2)+abs(is3 mod 2);
        if( isom1 = 0 )then ib:=0;
      end;
    65:
      if ((ik+il) mod 2) = 0 then ib:=0; {Face A centre}
    66:
      if ((il+ih) mod 2) = 0 then ib:=0; {Face B centre}
    67:
      if ((ih+ik) mod 2) = 0 then ib:=0; {Face C centre}
    82:                                  {Rhombodrique index en Hexagonal}
      begin
        if (systeme = 'HEXA') then begin
          if ( ((-ih+ik+il) mod 3) = 0) then ib:=0;
          if ( ((ih-ik+il) mod 3) = 0) then begin
            i:=ih;
            ih:=ik;
            ik:=i;
            ib:=0;
          end;
        end;
        if (systeme = 'RHOM') then ib:=0;
      end;
  end;
  if(ib = 0)then begin
    extin2(ih,ik,il,ibon);
    ib:=ibon;
  end;
end;

procedure equivalentes(var h1,k1,l1,h2,k2,l2,ier : integer);
//---------------------------------------------------------
 var
    i,j,k,n,m,ih,ik,il         : integer;
    car                        : char;
    tpos                       : array[1..24,1..3,1..3] of integer;
    ndeg                       : integer;
 const
    itc                  : array[1..54] of integer =
     (1, 0, 0,  0, 1, 0,  0, 0, 1,
      0, 1, 0,  0, 0, 1,  1, 0, 0,
      0, 0, 1,  1, 0, 0,  0, 1, 0,
      1, 0, 0,  0, 0, 1,  0, 1, 0,
      0, 1, 0,  1, 0, 0,  0, 0, 1,
      0, 0, 1,  0, 1, 0,  1, 0, 0);

    itq                  : array[1..18] of integer =
      (1,0,0,  0,1,0,  0,0,1,
       0,1,0,  1,0,0,   0,0,1);

    ith                  : array[1..18] of integer =
     ( 1, 0, 0,  0, 1, 0,  0, 0, 1,
       0, 1, 0,  1, 0, 0,  0, 0, 1);

    itr                  : array[1..54] of integer =
    (1,0,0, 0,1,0,  0,0,1,
     0,1,0, 0,0,1,  1,0,0,
     0,0,1, 1,0,0,  0,1,0,
     0,1,0, 1,0,0,  0,0,1,
     0,0,1, 0,1,0,  1,0,0,
     1,0,0,  0,0,1, 0,1,0);

    itm                  : array[1..18] of integer =
      (1,0,0,  0,1,0,  0,0,1,
      -1,0,0,  0,1,0,  0,0,-1);

 begin
    if (systeme = 'ORTH') or (systeme = 'TRIC')then exit;
    car:=systeme[1];
    if (systeme = 'TETR')then car:='Q';
    case car of
      'C': ndeg:=6;
      'Q': ndeg:=2;
      'H': ndeg:=2;
      'R': ndeg:=6;
      'M': ndeg:=2;
    end;

    n:=0;
    for k:=1 to ndeg do begin
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          n:=n+1;
          case car of
           'C': m:=itc[n];
           'Q': m:=itq[n];
           'H': m:=ith[n];
           'R': m:=itr[n];
           'M': m:=itm[n];
          end;
          tpos[k,i,j]:=m;
        end;
      end;
    end;
    for k:=2 to ndeg do begin
      ih:=round(tpos[k,1,1]*h2+tpos[k,1,2]*k2+tpos[k,1,3]*l2);
      ik:=round(tpos[k,2,1]*h2+tpos[k,2,2]*k2+tpos[k,2,3]*l2);
      il:=round(tpos[k,3,1]*h2+tpos[k,3,2]*k2+tpos[k,3,3]*l2);
      if ((ih = h1) and (ik = k1) and (il = l1)) or
      ((ih = -h1) and (ik = -k1) and (il = -l1)) then begin
        ier:=1;
        exit;
      end;
    end;

end;

procedure genere_indices(var ier : integer);
//------------------------------------------
var
  h_groupe,k_groupe,l_groupe,nb_total                  : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ih,ik,il,n,m             : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,d                                  : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  result                                               : array[1..10000] of ^reflection;
  groupe                                               : array[1..192] of reflection;
  buf                                                  : reflection;
  xlp,theta_rad,echel,xx                               : real;
  r1,r2,r3                                             : real;
  tphkl                                                : tab_it;
  npos_hkl                                             : integer;
  
begin

//Tableau des equivalents hkl 10/07/02
  n:=0;
  if (nb_translation > 0)then m:=npos div nb_translation else m:=npos;
  for i:=1 to m do begin
      n:=n+1;
      for j:=1 to 3 do
      for k:=1 to 3 do tphkl[n,j,k]:=round(tp[i,j,k]);
  end;
  npos_hkl:=n ;
  if (centre = false)then begin
    for i:=1 to npos_hkl do begin
      for j:=1 to 3 do
      for k:=1 to 3 do tphkl[i+npos_hkl,j,k]:=-tphkl[i,j,k];
    end;
    npos_hkl:=2*npos_hkl;
  end;

  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'HEXA')then bravais:='P';

//limites des boucles
  setmat;
  xx:=2*sin(theta_max_depart/(57.2957*2))/lambda;

//22 mai 20002: Nouveau calcul des limites d'indices (voir Cranswick)
  h:=1;
  h2:=0;
  for k:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= h2)then h2:=i;
    end;
  end;

  k:=1;
  k2:=0;
  for h:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= k2)then k2:=i;
    end;
  end;

  l:=1;
  l2:=0;
  for h:=0 to 1 do begin
    for k:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= l2)then l2:=i;
    end;
  end;
  h2:=h2+1;
  k2:=k2+1;
  l2:=l2+1;
  
  lbds2:=lambda/2;
  r2hkl_min:=2*sin(theta_min_depart/114.5914)/lambda;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  r2hkl_max:=2*sin(theta_max_depart/114.5914)/lambda;
  r2hkl_max:=(r2hkl_max*r2hkl_max);

  nb_raie:=0;
  if (systeme = 'CUBI')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=k to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);

          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TETR')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'ORTH')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'HEXA')then begin
    for h:=0 to h2 do begin
      for k:=h to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'RHOM')then begin
    for h:=0 to h2 do begin
      for k:=h to h2 do begin
        for l:=-h2 to h2 do begin
          if (h = 0) and (k = 0)  and (l = 0) then continue;
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'MONO')then begin
    for h:=h2 downto -h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TRIC')then begin
    for h:=-h2 to h2 do begin
      for k:=-k2 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          d:=1/sqrt(r2hkl);
          nb_raie:=nb_raie+1;
          if (nb_raie >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            for i:=1 to nb_raie do dispose(result[i]);
            ier:=1;
            exit;
          end;
          new (result[nb_raie]);
          with result[nb_raie]^ do begin
            h:=ih;
            k:=ik;
            l:=il;
            dhkl:=d;
          end;
        end;
      end;
    end;
  end;
  nb_total:=nb_raie;

//Mise en ordre
  for i:=1 to nb_raie-1 do begin
    for j:=i+1 to nb_raie do begin
      if (result[i]^.dhkl < result[j]^.dhkl) then begin
        buf:=result[j]^;
        result[j]^:=result[i]^;
        result[i]^:=buf;
      end;
    end;
  end;

//Dtection des raies gnres quivalentes
  for i:=1 to nb_raie-1 do begin
    for j:=i+1 to nb_raie do begin
      if (result[j]^.dhkl = 0) then continue;
      if (abs(result[i]^.dhkl-result[j]^.dhkl) < 0.0001)then begin
        with result[i]^ do begin
          h1:=h;
          k1:=k;
          l1:=l;
        end;
        with result[j]^ do begin
          h2:=h;
          k2:=k;
          l2:=l;
        end;
        ier:=0;
        equivalentes (h1,k1,l1,h2,k2,l2,ier);
        if (ier = 1) then begin
           result[j]^.dhkl:=0;
           continue;
        end;
      end;
    end;
  end;

//Elimination des raies si dhkl=0
  n:=0;
  for i:=1 to nb_raie do begin
      if (result[i]^.dhkl = 0)then continue;
      n:=n+1;
      result[n]^:=result[i]^;
  end;
  nb_raie:=n;

//Calcul de la multiplicit
  ier:=0;
  for i:=1 to nb_raie do begin
    with result[i]^ do begin
      h2:=h;
      k2:=k;
      l2:=l;
    end;
    for k:=1 to npos_hkl do begin
      groupe[k].h:=tphkl[k,1,1]*h2+tphkl[k,2,1]*k2+tphkl[k,3,1]*l2;
      groupe[k].k:=tphkl[k,1,2]*h2+tphkl[k,2,2]*k2+tphkl[k,3,2]*l2;
      groupe[k].l:=tphkl[k,1,3]*h2+tphkl[k,2,3]*k2+tphkl[k,3,3]*l2;
    end;
    for j:=1 to npos_hkl-1 do begin
      if (groupe[j].h = 0) and (groupe[j].k = 0) and (groupe[j].l =0) then continue;
      for k:= j+1 to npos_hkl do begin
        if (groupe[k].h = 0) and (groupe[k].k = 0) and (groupe[k].l =0) then continue;
        if (groupe[j].h = groupe[k].h) and
           (groupe[j].k = groupe[k].k) and
           (groupe[j].l = groupe[k].l) then begin
           groupe[k].h:=0;groupe[k].k:=0;groupe[k].l:=0;
        end;
      end;
    end;
    n:=0;
    for j:=1 to npos_hkl do begin
      if (groupe[j].h = 0) and (groupe[j].k = 0) and (groupe[j].l =0) then continue;
      n:=n+1
    end;

    result[i]^.mult:=n;
    raies_part[i]:=result[i]^;
    raies_part[i].dtheta:=114.591559*arcsin(lambda/(2*raies_part[i].dhkl));
    raies_part[i].wl:=lambda;
    raies_part[i].int:=1;
  end;

//Libration mmoire
  for i:=1 to nb_total do dispose(result[i]);

end;

procedure generX;{
-----------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,hh,kk,ll,h1,h2,k1,k2,l1,l2,ier                   : integer;
  hmax,kmax,lmax                                       : integer;
  x,y,z,r2hkl,lbds2,dhkl,theta,ech_norm                : double;
  r2hkl_min,r2hkl_max,sithl,den                        : double;
  ih,ik,il                                             : tab_int48;
  nr                                                   : integer;
  a_plus,b_plus,a_moins,b_moins                        : double;
  xlp,theta_rad,echel                                  : double;
  s                                                    : string;
  F_p,F_m,fp,fs,f2                                     : double;
  a_p,b_p,a_m,b_m,l_pol,f_moy                          : array[1..10000] of real;
begin

  bravais:=copy(groupe_espace,1,1);

//Gnration des indices
  genere_indices(ier);
  if (ier = 1)then begin
    beep;
    erreur('No reflection calculated in the given Theta range!');
    exit;
  end;

//Calcul de l'intensit des raies
  ymax:=0;
  lbds2:=lambda_calc/2;
  for i:=1 to nb_raie do begin
    with raies_part[i] do begin
      theta_rad:=arcsin(lbds2/dhkl);
      sithl:=1/(2*dhkl);
      hh:=h;
      kk:=k;
      ll:=l;
      dtheta:=2*57.2957*theta_rad;
    end;

//Calcul du facteur de structure
    fstrX(hh,kk,ll,sithl,a_plus,b_plus,a_moins,b_moins);

//Calcul de l'intensit
    f2:=0.5*(a_plus*a_plus+b_plus*b_plus+a_moins*a_moins+b_moins*b_moins);
    den:=cos(theta_rad)*sqr(sin(theta_rad));
    case type_lp of
        0: xlp:=0.5*(1+sqr(cos(theta_rad*2)))/den;
        1: xlp:=(1-probabilite+probabilite*sqr(cos(theta_rad*2)))/den;
    end;
     f2:=f2*raies_part[i].mult*xlp;
     if (f2 < 0.05)then f2:=0.05;   //?

//Mise en tableau
     l_pol[i]:=xlp;
     a_p[i]:=a_plus;
     b_p[i]:=b_plus;
     a_m[i]:=a_moins;
     b_m[i]:=b_moins;
     raies_part[i].int:=f2;

//Recherche max
     if (f2 > ymax)then ymax:=f2;
  end;

  if (nb_tour = 1)then begin
    echel:=1000/ymax;
    norme:=0;
    for i:=1 to nb_atome do begin
      x:=cf[i];
      for j:=1 to 4 do x:=x+af[no_atome[i],j];
      norme:=norme+mult[i]*mult_max*x*x;
    end;
    writeln(nom_fic1);
    ech_norm:=5000/(volume*norme);
    writeln(nom_fic1,'The intensities were multiplied by:',ech_norm:13);
  end;

  //Ecriture
  writeln(nom_fic1);
  writeln(nom_fic1,'Results for lambda=',lambda_calc:8:5);
  writeln(nom_fic1);

  writeln(nom_fic1,
  ' Nb    h  k  l   2Theta   dhkl    N    LP       Intensity ');
  for i:=1 to nb_raie do begin
    with raies_part[i] do begin
      writeln(nom_fic1,i:3,'  ',h:3,k:3,l:3,
      dtheta:9:3,dhkl:8:4,mult:4,l_pol[i]:7:2,'  ',
      ech_norm*int:11:2{,echel*int:11:2});
      int:=int*ech_norm;
    end;
  end;

  //Ecriture des facteurs de structure dans le fichiers fstr2.out
  writeln(nom_fic1);
  writeln(nom_fic1,'Structure factors');
  writeln(nom_fic1,
  ' Nb    h  k  l     A+      B+      A-      B-       F+       F-'+
  '      Fmoy');
  for i:=1 to nb_raie do begin
    with raies_part[i] do begin
      f_p:=sqrt(sqr(a_p[i])+sqr(b_p[i]));
      f_m:=sqrt(sqr(a_m[i])+sqr(b_m[i]));
      f_moy[i]:=(f_p+f_m)/2;
      writeln(nom_fic1,i:3,'  ',h:3,k:3,l:3,
      a_p[i]:8:2,b_p[i]:8:2    ,a_m[i]:8:2,b_m[i]:8:2,f_p:9:2,f_m:9:2,
      f_moy[i]:9:2);
    end;
  end;

  //Ecriture des facteurs de diffusion atomique (Lauriat)
   writeln(nom_fic1);
   writeln(nom_fic1,'Atomic scattering factors');
   writeln(nom_fic1,' Nb    h  k  l   1/2dhkl   atom      f         f''       f'''' ');
   for i:=1 to nb_raie do begin
       hh:=raies_part[i].h;
       kk:=raies_part[i].k;
       ll:=raies_part[i].l;
       dhkl:=raies_part[i].dhkl;
       sithl:=1/(2*dhkl);
       writeln(nom_fic1,i:3,'  ',hh:3,kk:3,ll:3,sithl:10:5);
       for j:=1 to nb_element do begin
         f(j,sithl,fp,fs);
         writeln(nom_fic1,'                            ',element[j],
        (fp-delfr[nb_tour,j]):10:2,delfr[nb_tour,j]:10:2,fs:10:2);
       end;
  end;

//============Ecriture des intensits dans le fichier fstr.out==================
if (nb_tour = 1)then begin
//==============================================================================

  if (type_lp = 0)then begin
    writeln(nom_fic2,
'POUDRIX : Calculated powder diffraction diagram (Source: Xray tube)');
    writeln(nom_fic2,
'----------------------------------------------------------------------------');
  end else begin
    writeln(nom_fic2,
'POUDRIX : Calculated powder diffraction diagram (Source: Synchrotron)');
    writeln(nom_fic2,
'----------------------------------------------------------------------------');
          writeln(nom_fic2);
          writeln(nom_fic2,'Polarisation p=',probabilite:7:2);
  end;

  writeln(nom_fic2);
  s:=DateTimeToStr(Now);
  Writeln(nom_fic2,s);
  writeln(nom_fic2);
  writeln(nom_fic2,'Results for:'+titre);
  writeln(nom_fic2,'Cell    : ',cel[1]:8:3,cel[2]:8:3,cel[3]:8:3,
  cel[4]:8:3,cel[5]:8:3,cel[6]:8:3);
  //writeln(nom_fic2,'lambda  : ',lambda_calc:10:5);
  writeln(nom_fic2,'Sp.Group: ',groupe_espace);
  writeln(nom_fic2,'System  : ',systeme);
  writeln(nom_fic2,'Lattice : ',bravais);
  writeln(nom_fic2,'2Theta Min =',theta_min:7:2);
  writeln(nom_fic2,'2Theta Max =',theta_max:7:2);

  writeln(nom_fic2,'Asymetric unit content:');
  if (type_source =1)then begin
     writeln(nom_fic2,
    '         x        y        z      B      Pop.   Mult. Elem. Nb.');
    j:=nb_atome;
    //if (icent=1) then j:=nb_atome div 2 ;
    for i:=1 to j do
    writeln(nom_fic2,atome[i]:2,labell[i]:2,x_at[i]:9:5,y_at[i]:9:5,z_at[i]:9:5,
    btherm[i]:6:2,pop[i]:8:3,mult[i]:8:3,no_atome[i]:5);
    writeln(nom_fic2);
  end;
//=============================================================================
end;
//=============================================================================
  writeln(nom_fic2);
  writeln(nom_fic2,'Results for lambda=',lambda_calc:8:5);
  //writeln(nom_fic2,'To normalise to 1000, multiply the intensities by',x:14);
  writeln(nom_fic2);

  if (systeme = 'RHOM') then begin
    writeln(nom_fic2,
    '   h   k   l   dhkl   2Theta  Mult  Lp      Fhkl   Intensity   Hexa indices')
  end else if (systeme = 'HEXA') and (bravais = 'R')then begin
    writeln(nom_fic2,
    '   h   k   l   dhkl   2Theta  Mult  Lp      Fhkl   Intensity  Rhombo indices')
  end else begin
     writeln(nom_fic2,
    '   h   k   l   dhkl   2Theta  Mult  Lp      Fhkl   Intensity')
  end;
  writeln(nom_fic2);
  for i:=1 to nb_raie do begin
      write(nom_fic2,raies_part[i].h:4,raies_part[i].k:4,raies_part[i].l:4,
      raies_part[i].dhkl:8:4,raies_part[i].dtheta:8:3,raies_part[i].mult:4,
      l_pol[i]:7:2,f_moy[i]:10:2,
      raies_part[i].int:10:2);
      if (systeme = 'RHOM') then begin
        hh:=raies_part[i].h-raies_part[i].k;
        kk:=raies_part[i].k-raies_part[i].l;
        ll:=raies_part[i].h+raies_part[i].k+raies_part[i].l;
        writeln(nom_fic2,'    ',hh:4,kk:3,ll:3);
      end else if (systeme = 'HEXA') and (bravais = 'R') then begin
        hh:=(2*raies_part[i].h+raies_part[i].k+raies_part[i].l) div 3;
        kk:=(raies_part[i].h+raies_part[i].k+raies_part[i].l) div 3;
        ll:=(-raies_part[i].h-2*raies_part[i].k+raies_part[i].l) div 3;
        writeln(nom_fic2,'    ',hh:3,kk:3,ll:3);
      end else begin
        //writeln(nom_fic2,part_raies[i].mult:4);
        writeln(nom_fic2);
      end;
  end;
end;

procedure generN;{
-----------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier                      : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,dhkl,theta,ech_norm                : double;
  r2hkl_min,r2hkl_max,sithl,den                        : double;
  ih,ik,il                                             : tab_int48;
  nr                                                   : integer;
  a_plus,b_plus                                        : double;
  xlp,theta_rad,echel                                  : double;
// it                                                   : tab_it;
  s                                                    : string;
  F_p,F_m,fp,fs,f2                                     : double;
  a_p,b_p,a_m,b_m,l_pol,f_moy                          : array[1..10000] of real;
begin

  bravais:=copy(groupe_espace,1,1);

//Gnration des indices
  genere_indices(ier);
  if (ier = 1)then begin
    beep;
    erreur('No reflection calculated in the given Theta range!');
    exit;
  end;

  //Calcul de l'intensit des raies
  ymax:=0;
  lbds2:=lambda_calc/2;
  for i:=1 to nb_raie do begin

    theta_rad:=arcsin(lbds2/raies_part[i].dhkl);
    sithl:=1/(2*raies_part[i].dhkl);
    h:=raies_part[i].h;
    k:=raies_part[i].k;
    l:=raies_part[i].l;
    raies_part[i].dtheta:=2*57.2957*theta_rad;

    //Calcul du facteur de structure
    fstrN(h,k,l,sithl,a_plus,b_plus);

    //Calcul de l'intensit
    f2:=(a_plus*a_plus+b_plus*b_plus);
    den:=cos(theta_rad)*sqr(sin(theta_rad));
    xlp:=1/den;
    f2:=f2*raies_part[i].mult*xlp;
    if (f2 < 0.05)then f2:=0.05;   //?

     //Mise en tableau
     l_pol[i]:=xlp;
     a_p[i]:=a_plus;
     b_p[i]:=b_plus;
     raies_part[i].int:=f2;

     //Recherche max
     if (f2 > ymax)then ymax:=f2;
  end;

  //ech_norm:=1000/ymax;
  if (nb_tour = 1)then begin
     norme:=0;
     for i:=1 to nb_atome do norme:=norme+mult[i]*b_fermi[i];
     ech_norm:=1000/(npos*npos*npos*sqr(norme));
     if (icent = 1)then ech_norm:=ech_norm*4;
     writeln(nom_fic1,'The intensity was multiplied by:',ech_norm:13);
     x:=1000/(ech_norm*ymax);
     writeln(nom_fic1,'To normalise to 1000 multiply the intensities by',x:13);
     writeln(nom_fic1);
  end;

  writeln(nom_fic1);
  writeln(nom_fic1,'Results for lambda=',lambda_calc:8:5);
  writeln(nom_fic1);
  writeln(nom_fic1,
  ' No    h  k  l   2Theta   dhkl    N    LP       Intensity');

  for i:=1 to nb_raie do begin
    writeln(nom_fic1,i:3,'  ',raies_part[i].h:3,raies_part[i].k:3,raies_part[i].l:3,
    raies_part[i].dtheta:9:3,raies_part[i].dhkl:8:4,raies_part[i].mult:4,l_pol[i]:7:2,'  ',
    ech_norm*raies_part[i].int:11:2);
    raies_part[i].int:=raies_part[i].int*ech_norm;
  end;

  //Ecriture des facteurs de structure dans le fichiers fstr2.out
  writeln(nom_fic1);
  writeln(nom_fic1,'Structure factors');
  writeln(nom_fic1,
  ' No    h  k  l     A       B        F');

  for i:=1 to nb_raie do begin
      f_p:=sqrt(sqr(a_p[i])+sqr(b_p[i]));
      //f_m:=sqrt(sqr(a_m[i])+sqr(b_m[i]));
      //f_moy[i]:=(f_p+f_m)/2;
      f_moy[i]:=f_p;
      writeln(nom_fic1,i:3,'  ',raies_part[i].h:3,raies_part[i].k:3,raies_part[i].l:3,
      a_p[i]:8:3,b_p[i]:8:3  ,f_p:9:4);
  end;

//----------------------------Ecriture fstr.out --------------------------------
  if (nb_tour = 1)then begin
//------------------------------------------------------------------------------
    writeln(nom_fic2,
'POUDRIX : Powder diffraction diagram (Source: Neutrons)');
    writeln(nom_fic2,
'-------------------------------------------------------');

  writeln(nom_fic2);
  s:=DateTimeToStr(Now);
  Writeln(nom_fic2,s);
  writeln(nom_fic2);
  writeln(nom_fic2,'Results for:'+titre);
  writeln(nom_fic2,'Cell     : ',cel[1]:8:3,cel[2]:8:3,cel[3]:8:3,
  cel[4]:8:3,cel[5]:8:3,cel[6]:8:3);
 // writeln(nom_fic2,'lambda   : ',lambda_calc:10:5);
  writeln(nom_fic2,'Sp. group: ',groupe_espace);
  writeln(nom_fic2,'System   : ',systeme);
  writeln(nom_fic2,'Lattice  : ',bravais);
  //writeln(nom_fic2,'lambda     =',lambda_calc:10:5);
  writeln(nom_fic2,'2Theta Min =',theta_min:7:2);
  writeln(nom_fic2,'2Theta Max =',theta_max:7:2);

  writeln(nom_fic2,'Asymetric unit content:');
  if (type_source =2)then begin
     writeln(nom_fic2,
    '       Nb     x        y        z      B      Pop.   Mult.   B Fermi ');
    j:=nb_atome;
    if (icent=1) then j:=nb_atome div 2 ;
    for i:=1 to j do
    writeln(nom_fic2,atome[i]:2,labell[i]:2,no_atome[i]:5,x_at[i]:9:5,y_at[i]:9:5,
    z_at[i]:9:5,btherm[i]:6:2,pop[i]:8:3,mult[i]:8:3,b_fermi[i]:8:2);
    writeln(nom_fic2);
  end;
 //-----------------------------------------------------------------------------
 end;
 //-----------------------------------------------------------------------------
  writeln(nom_fic2);
  writeln(nom_fic2,'Results for lambda=',lambda_calc:8:5);
  //writeln(nom_fic2,'To normatise to 1000 multiply the intensities by',x:14);
  writeln(nom_fic2);
  writeln(nom_fic2);

  if (systeme = 'RHOM') then begin
    writeln(nom_fic2,
    '   h   k   l   dhkl   2Theta  Mult  Lp      Fhkl   Intensity   Hexa indices')
  end else if (systeme = 'HEXA') and (bravais = 'R')then begin
    writeln(nom_fic2,
    '   h   k   l   dhkl   2Theta  Mult  Lp      Fhkl   Intensity  Rhombo indices')
  end else begin
     writeln(nom_fic2,
    '   h   k   l   dhkl   2Theta  Mult  Lp      Fhkl   Intensity')
  end;
  writeln(nom_fic2);
  for i:=1 to nb_raie do begin
      write(nom_fic2,raies_part[i].h:4,raies_part[i].k:4,raies_part[i].l:4,raies_part[i].dhkl:8:4,
      raies_part[i].dtheta:8:3,raies_part[i].mult:4,l_pol[i]:7:2,f_moy[i]:10:2,
      raies_part[i].int:10:2);
      if (systeme = 'RHOM') then begin
        hh:=raies_part[i].h-raies_part[i].k;
        kk:=raies_part[i].k-raies_part[i].l;
        ll:=raies_part[i].h+raies_part[i].k+raies_part[i].l;
        writeln(nom_fic2,'    ',hh:4,kk:3,ll:3);
      end else if (systeme = 'HEXA') and (bravais = 'R') then begin
        hh:=(2*raies_part[i].h+raies_part[i].k+raies_part[i].l) div 3;
        kk:=(raies_part[i].h+raies_part[i].k+raies_part[i].l) div 3;
        ll:=(-raies_part[i].h-2*raies_part[i].k+raies_part[i].l) div 3;
        writeln(nom_fic2,'    ',hh:3,kk:3,ll:3);
      end else begin
        writeln(nom_fic2);
      end;
  end;
end;

end.
