unit mathhkl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math;

type
   tab_single10000                              = array[1..30000] of single;
   tab_int1000                                  = array[1..1000] of smallint;
   tab_mess                                     = array[1..100] of smallint;
   tab_cara                                     = array[1..492] of smallint;
   tab_reel                                     = array[1..501] of single;
   matrice3                                     = array[1..3,1..3] of double ;
   vecteur3                                     = array[1..3] of double;
   vecteur4                                     = array[1..4] of double;
   string4                                      = string[4];
   tab_dec                                      = array[1..11] of double;
   tab_mess2                                    = array[1..16] of integer;
type reflection = record
  h,k,l,mult            : integer;
  wl,dhkl,dtheta,int    : double;
end;
type raie_esp_rec = record
  h,k,l                 : integer;
  q,int                 : double;
end;

const
  tab_fermi:array[1..102] of double =(
 -0.203,  0.780,  0.535,  0.665,  0.936,  0.580,  0.566,  0.460,
  0.363,  0.538,  0.345,  0.415,  0.513,  0.285,  0.958,  0.180,
  0.371,  0.490,  1.215, -0.337, -0.041,  0.353, -0.373,  0.954,
  0.278,  1.030,  0.769,  0.570,  0.720,  0.819,  0.673,  0.795,
  0.677,  0.791,  0.708,  0.688,  0.775,  0.700,  0.711,  0.695,
  0.680,  0.721,  0.588,  0.600,  0.602,  0.380,  0.408,  0.622,
  0.564,  0.543,  0.528,  0.488,  0.542,  0.528,  0.827,  0.483,
  0.445,  0.780,  0.000, -0.500,  0.550,  1.500,  0.738,  1.710,
  0.850,  0.803,  0.705,  1.262,  0.730,  0.777,  0.691,  0.477,
  0.920,  1.080,  1.060,  0.950,  0.763,  1.266,  0.889,  0.940,
  0.853,  0.000,  0.000,  0.000,  0.000,  0.000,  0.000,  1.008,
  1.300,  0.861,  1.060,  0.750,  0.760,  0.700,  0.000,  0.000,
 -0.374,  0.667, -0.220,  1.440,  0.280,  1.109);
var
   repertoire_origine                           : string;
   nom_fichier_cry                              : string;
   nom_fichier_raw                              : string;
   nom_fichier_dif                              : string;
   r10,r01,r21,r12,r13,r31,r23,r32,r20,r02      : matrice3;

   {Maille}
   titre                                        : string;
   systeme                                      : string;
   no_systeme                                   : integer;
   groupe_espace                                : string[12];
   bravais                                      : string[1];
   rhom_hexa                                    : integer;
   cel                                          : array[1..6] of double;
   //a,b,c,alpha,beta,gamma                       : double;
   celr                                         : array[1..6] of double;
   volume                                       : double;

   {Coordonnes du motif asymtrique}
   x_at,y_at,z_at,btherm,pop,mult,b_fermi       : array[1..200] of double;
   atome                                        : array[1..200] of string[4];
   labell                                       : array[1..200] of string[2];
   no_atome                                     : array[1..200] of integer;
   nb_atome                                     : integer;

   //Symtrie
   npos,icent,nb_groupes_getspec,nb_groupes_HM  : integer;
   tp                                           : array[1..192,1..3,1..4]of double;
   centre                                       : boolean;
   nb_translation                               : integer;
   tx,ty,tz                                     : array[1..4] of double;
   s_pos                                        : array[1..192] of string[24];
   mode                                         : string;

   // Conditions d'extinction  (nb_ligne_code)
   ligne_codeEN                                 : array[1..10] of string[40];
   nb_ligne_code                                : integer;
   nb_condition_si                              : array[1..6] of integer;
   no_condition_si                              : array[1..6,1..5] of integer;
   no_action_do                                 : array[1..6] of integer;

   // Coefficients de Cromer
   af,bf                                        : array[1..20,1..4] of double;
   cf                                           : array[1..20] of double;
   delfr,delfi                                  : array[1..4,1..20] of double;
   element                                      : array[1..20] of string[4];
   nb_element                                   : integer;

   {Manip}
   theta_min,theta_max,theta_min_depart,theta_max_depart,etendue : double;
   q_min,q_max,q_min_depart,q_max_depart             : double;
   manip_typ                                         : string[2];
   u,v,w                                             : double;
   lambda,lambda2,lamba3                             : double;
   nature_lambda                                     : array[1..4] of string[6];
   nb_lambda,type_lp,type_echelle,type_source,nb     : integer;
   probabilite                                       : double;
   modif_donnees                                     : boolean;

   //Impurets
   wl_impur,pcent_impur                              : array[1..10] of double;
   nb_wl_impur                                       : integer;
   lambda_calc,lambda_min,lambda_max                 : double;

   {Rsultats POUDRIX}
   nb_raie                                      : integer;
   raies_part                                   : array[1..10000] of reflection;
   q_tot                                        : array[1..10000] of raie_esp_rec;
   qint_max                                     : double;

   //Raies pour source multiple
   nb_raie_tot                                  : integer;
   raies_tot                                    : array[1..40000] of reflection;

   //Profil
   nb_pro                                       : integer;
   x_pro,y_pro,q_pro                            : array[1..1015] of single;
   nb_proN                                      : integer;
   x_proN,y_proN,q_proN                         : array[1..1015] of single;
   pas                                          : double;

   {Fichier_raw}
   nb_fichier_raw                               : integer;
   lambda_fichier_raw                           : array[1..10] of double;
   x_raw,y_raw ,q_raw                           : tab_single10000;
   nb_raie_raw                                  : integer;
   lambda_raw,lambda1_raw,lambda2_raw,ratio_raw : double;
   anode_raw,anode_calc                         : string[2];
   theta_min_raw,theta_max_raw,pas_raw          : double;
   ymax_raw,ymin_raw                            : double;
   titre_raw                                    : string;

   //Spectres raw stockage
   nbraw_pro                                    : integer;
   xraw_pro,yraw_pro,qraw_pro                   : array[1..10,1..1015] of double;
   nom_raw                                      : array[1..10] of string[50];
   nb_tour                                      : integer;

   {Fentre graphique}
   largeur,y_bas,y_haut,y_milieu,xo_fenetre,yo_fenetre   : integer;

   // sortie
   result_int                                   : tab_single10000;
   result_h,result_k,result_l                   : tab_int1000;
   nom_fic1,nom_fic2                            : textfile;

   ymax,ymin,theta1,theta2                      : single;
   facteur_echelle                              : double;
   contenu_maille                               : double;

   procedure erreur(s:string);
   procedure verif(var s:string);
   procedure dec(s:string; var tableau:tab_dec; var no,ier:integer);
   procedure setmat;
   procedure calc_hkl(var h,k,l: integer; var d:double);
   procedure lit_poudrix(var ier:integer);
   procedure lit_shelx_out(var ier:integer);
   procedure lit_shelx_inp(var ier:integer);
   procedure lit_powdercell(var ier:integer);
   procedure lit_icsd(var ier:integer);
   procedure lit_lazyPulverix(var ier:integer);
   procedure quel_systeme;
   
implementation

procedure erreur(s:string);{
---------------------------}
begin
   MessageDlg(s,mtWarning,[mbOK],0);
end;

{Guerrit les .0 0. et -.}
procedure verif(var s:string);{
------------------------------}
var
  n         :integer;
begin
  if (s = '')then begin
    s:='0';
    exit;
  end;
  n:=pos(' .',s);
  if(n < 0)then s[n]:='0';
  n:=pos('. ',s);
  if(n > 0)then s[n+1]:='0';
  n:=pos('-.',s);
  if(n > 0)then insert('0',s,n+1);
  n:=length(s);
  if(s[n] = '.') then s:=s+'0';
end;

procedure quel_systeme;
//---------------------
var
  dif1,dif2,dif3          : double;
begin
 dif1:=abs(cel[1]-cel[2]);
 dif2:=abs(cel[2]-cel[3]);
 dif3:=abs(cel[3]-cel[1]);
 if (cel[4] = 90) and (cel[5] = 90) and (cel[6] = 90)then begin
   if (dif1 < 0.001) and (dif2 < 0.001) and (dif3 < 0.001)then begin
     systeme:='CUBI';
     exit;
   end;
   if (dif1 < 0.001) and (dif2 > 0.001) then begin
     systeme:='QUAD';
     exit;
   end;
   if (dif1 > 0.001) and (dif2 > 0.001) then begin
     systeme:='ORTH';
     exit;
   end;
 end else if (cel[4] = 90) and (cel[5] = 90) and (cel[6] = 120)then begin
   systeme:='HEXA';
   exit;
 end else if (dif1 < 0.001) and (dif2 < 0.001) and (dif3 < 0.001) then begin
   systeme:='RHOM';
   exit;
 end else if (cel[4] = 90) and (cel[5] <> 90) and (cel[6] = 90)then begin
   systeme:='MONO';
   exit;
 end else if (cel[4] = 90) and (cel[5] = 90) and (cel[6] <> 90)then begin
   systeme:='MONO';
   exit;
 end else begin
   systeme:='TRIC';
   exit;
 end;
end;

procedure setmat;
//---------------
var
      a,b,c                                : double;
      sa,sb,sc,sbe,sce,ca,cb,cc            : double;
      cae,cbe,cce                          : double;
      q,v                                  : double;
      i,j                                  : integer;
begin
      a:=cel[1];b:=cel[2];c:=cel[3];
      ca:=cos(cel[4]/57.2957);
      cb:=cos(cel[5]/57.2957);
      cc:=cos(cel[6]/57.2957);
      sa:=sin(cel[4]/57.2957);
      sb:=sin(cel[5]/57.2957);
      sc:=sin(cel[6]/57.2957);
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      volume:=v;
      celr[1]:=b*c*sa/v;
      celr[2]:=c*a*sb/v;
      celr[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      celr[4]:=arccos(cae);
      celr[4]:=celr[4]*57.2957;
      celr[5]:=arccos(cbe);
      sbe:=sin(celr[5]);
      celr[5]:=celr[5]*57.2957;
      celr[6]:=arccos(cce);
      sce:=sin(celr[6]);
      celr[6]:=celr[6]*57.2957;
{-----Orthonormalisation du rseau rciproque R21}
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r21[i,j]:=0;
        end;
      end;
      r21[1,1]:=celr[1];
      r21[1,2]:=celr[2]*cce;
      r21[1,3]:=celr[3]*cbe;
      r21[2,2]:=celr[2]*sce;
      r21[2,3]:=-celr[3]*sbe*ca;
      r21[3,3]:=1./cel[3];

  end;

procedure calc_hkl(var h,k,l: integer; var d:double);
//------------------------------------------------
var
  x,y,z    :double;
begin
  x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
  y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
  z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
  d:=1/sqrt(x*x+y*y+z*z);
end;

//============================= Lecture fichiers cry ==========================

//Extrait jusqu' 11 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dec(s:string; var tableau:tab_dec; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..11] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
  chdir(repertoire_origine);
end;

Procedure traite_nom_element(var s:string);
//----------------------------------------
var
  c          : char;
begin
  c:=s[2];
  if (ord(c) > 47) and (ord(c) < 58)then insert(' ',s,2);
end;

procedure lit_poudrix(var ier:integer);
//-------------------------------------
var
 nomf               : textfile;
 x1,x2,x3,x4,x5     : double;
 ato                : string[4];
 lab_atome          : string[2];
// s                  : string;
// s2                 : string[12];
begin
      ier:=0;
      AssignFile(nomf,nom_fichier_cry);
      reset(nomf);
      readln(nomf,titre);
      readln(nomf,systeme);
      systeme:=copy(systeme,1,4);
      systeme:=uppercase(systeme);
      if (systeme = 'QUAD')then systeme:='TETR';
      readln(nomf,groupe_espace);
      groupe_espace:=trim(groupe_espace);
      readln(nomf,cel[1],cel[2],cel[3],cel[4],cel[5],cel[6]{,lambda});
      setmat;
      nb_atome:=0;
      while not(eof(nomf)) do begin
        nb_atome:=nb_atome+1;
        if (nb_atome > 200)then begin
          erreur('The number of atoms is > 200!');
          closefile(nomf);
          chdir(repertoire_origine);
          ier:=1;
          exit;
        end;
        readln(nomf,ato,lab_atome,x1,x2,x3,x4,x5);
        ato:=trimleft(ato);
        lab_atome:=trimleft(lab_atome);
        atome[nb_atome]:=ato;
        labell[nb_atome]:=lab_atome;
        x_at[nb_atome]:=x1;
        y_at[nb_atome]:=x2;
        z_at[nb_atome]:=x3;
        btherm[nb_atome]:=x4;
        pop[nb_atome]:=x5;
      end;
      closefile(nomf);
      chdir(repertoire_origine);
end;

procedure lit_shelx_out(var ier:integer);
//---------------------------------------
var
  nomf                                          : TextFile;
  s5                                            : string[5];
  s,s1                                          : string;
  s4                                            : string[4];
  s2                                            : string[2];
  c1                                            : string[1];
  ueq                                           : double;
  t,v,beta                                      : array[1..6] of double;
  valeur                                        : tab_dec;
  nb_valeurs,i,j                                : integer;
  type_fichier_shelx                            : integer;

begin
//==============================================
  type_fichier_shelx :=93; //(fichier de sortie);
//==============================================

  {Dtection de la maille}
  ier:=0;
  AssignFile(nomf,nom_fichier_cry);
  reset(nomf);
  while not eof(nomf) do begin
    readln(nomf,s5,s);
    if(s5 = ' CELL') then  begin
      dec(s,valeur,j,ier);
      for i:=1 to 6 do cel[i]:=valeur[i+1];
      break;
    end;
  end;
  quel_systeme;
  if (systeme = 'QUAD')then systeme:='TETR' ;
  closefile(nomf);

  setmat;

   t[1]:=sqr(cel[1]);t[2]:=sqr(cel[2]);t[3]:=sqr(cel[3]);
   t[4]:=cel[1]*cel[2]*cos(cel[6]/57.2957);
   t[5]:=cel[3]*cel[1]*cos(cel[5]/57.2957);
   t[6]:=cel[2]*cel[3]*cos(cel[4]/57.2957);
   v[1]:=celr[1]*celr[1];
   v[2]:=celr[2]*celr[2];
   v[3]:=celr[3]*celr[3];
   v[4]:=celr[1]*celr[2]*cos(celr[6]/57.2957);
   v[5]:=celr[1]*celr[3]*cos(celr[5]/57.2957);
   v[6]:=celr[2]*celr[3]*cos(celr[4]/57.2957);

//Shelx 90 ou 76?
  AssignFile(nomf,nom_fichier_cry);
  reset(nomf);
  type_fichier_shelx:=0;
  while not(eof(nomf)) do begin
    readln(nomf,s);
    if (pos('ATOM',s) > 0) and (pos('x         y         z',s) > 0)then begin
        type_fichier_shelx:=93;
        break;
    end;
    if (pos('ATOM',s) > 0) and (pos('X/A',s) > 0)then begin
        type_fichier_shelx:=76;
        break;
    end;
  end;
  closefile(nomf);
  if (type_fichier_shelx = 0)then begin
    erreur('The file '+extractFileName(nom_fichier_cry)+
    ' Seems not to be a Shelx file');
    exit;
  end;

//Lecture des coordonnes
  AssignFile(nomf,nom_fichier_cry);
  reset(nomf);
  ier:=1;
  while not eof(nomf) do begin
    s:='';
    readln(nomf,s);
    if(type_fichier_shelx = 93)then s1:='ATOM           x         y         z';
    if(type_fichier_shelx = 76)then s1:='ATOM      X/A';
    if (pos(s1,s) > 0 ) then begin
      ier:=0;
      break;
    end;
  end;

  if(ier = 1)then begin
    erreur
    ('No detected atom in the file '+extractFileName(nom_fichier_cry));
    closefile(nomf);
    ier:=1;
    exit;
  end;

  readln(nomf);
  while not eof(nomf) do begin
    readln(nomf,c1,s4,s);
    if (c1 = '')then break;
    s1:='';
    s1:=s1+c1;
    s1:=trim(s1);
    s4:=trim(s4);
    if(s4 = '') and (s1 = '')then break;                     //atome,x,y,etrc..
    readln(nomf);                                            //sigmas
    if(type_fichier_shelx = 93) then readln(nomf);           //ligne blanche
    for i:=1 to 10 do valeur[i]:=0;
    dec(s,valeur,nb_valeurs,ier);
    if(ier = 0) then begin
      nb_atome:=nb_atome+1;
      s4:=trim(s4);
      s:=copy(s4,1,4);
      traite_nom_element(s);s:=uppercase(s);
      atome[nb_atome]:=copy(s,1,2);
      labell[nb_atome]:=copy(s,3,2);
      s2:=copy(s,1,2);s2:=trim(s);
      x_at[nb_atome]:=valeur[1];
      y_at[nb_atome]:=valeur[2];
      z_at[nb_atome]:=valeur[3];
      pop[nb_atome]:=valeur[4];
      beta[1]:=valeur[5];
      beta[2]:=valeur[6];
      beta[3]:=valeur[7];
      beta[4]:=valeur[10];
      beta[5]:=valeur[9];
      beta[6]:=valeur[8];
      ueq:=0;
      for i:=1 to 6 do ueq:=ueq+beta[i]*t[i]*v[i];
      btherm[nb_atome]:=ueq*8*pi*pi/3;
    end else begin
      erreur('error '+s+' '+s4);
      exit;
    end;
  end;
  closeFile(nomf);
  chdir(repertoire_origine);
end;

procedure lit_shelx_inp(var ier:integer);
//---------------------------------------
var
  nomf                                          : TextFile;
  s4                                            : string[4];
  s,s1                                          : string;
  huipi2,ueq                                    : double;
  {u,}t,v                                         : array[1..6] of double;
  fvar                                          : array[1..30]of double;
  valeur                                        : tab_dec;
  nb_valeurs,i,j,p,m,k,nb_fvar                  : integer;
//  type_fichier_shelx                            : integer;

begin
//==============================================
 // type_fichier_shelx :=93; //(fichier d'entre);
//==============================================

  {Dtection de la maille}
  ier:=0;
  AssignFile(nomf,nom_fichier_cry);
  reset(nomf);
  while not eof(nomf) do begin
    readln(nomf,s4,s);
    if (s4 = 'TITL') then titre:=s;
    if (s4 = 'CELL') then  begin
      dec(s,valeur,j,ier);
      for i:=1 to 6 do cel[i]:=valeur[i+1];
      break;
    end;
  end;
  quel_systeme;
  if (systeme = 'QUAD')then systeme:='TETR' ;
  closefile(nomf);

  setmat;

  huipi2:=8*3.14159*3.14159;
  (*u[1]:=huipi2*celr[1]*celr[1]*cel[1]*cel[1];
  u[2]:=huipi2*celr[2]*celr[2]*cel[2]*cel[2];
  u[3]:=huipi2*celr[3]*celr[3]*cel[3]*cel[3];
  u[4]:=huipi2*celr[1]*celr[2]*cel[1]*cel[2]*cos(cel[6]/57.2957);
  u[5]:=huipi2*celr[1]*celr[3]*cel[1]*cel[3]*cos(cel[5]/57.2957);
  u[6]:=huipi2*celr[2]*celr[3]*cel[2]*cel[3]*cos(cel[4]/57.2957); *)

   t[1]:=sqr(cel[1]);t[2]:=sqr(cel[2]);t[3]:=sqr(cel[3]);
   t[4]:=cel[1]*cel[2]*cos(cel[6]/57.2957);
   t[5]:=cel[3]*cel[1]*cos(cel[5]/57.2957);
   t[6]:=cel[2]*cel[3]*cos(cel[4]/57.2957);
   v[1]:=celr[1]*celr[1];
   v[2]:=celr[2]*celr[2];
   v[3]:=celr[3]*celr[3];
   v[4]:=celr[1]*celr[2]*cos(celr[6]/57.2957);
   v[5]:=celr[1]*celr[3]*cos(celr[5]/57.2957);
   v[6]:=celr[2]*celr[3]*cos(celr[4]/57.2957);

  //Lecture des coordonnes
  AssignFile(nomf,nom_fichier_cry);
  reset(nomf);

  nb_atome:=0;
  while not eof(nomf) do begin
    readln(nomf,s4,s);
    s4:=uppercase(s4);
    nb_fvar:=0;
    if(s4 = 'FVAR') then begin
      dec(s,valeur,nb_valeurs,ier);
      if (ier > 0)then break;
      for i:=1 to nb_valeurs do fvar[nb_fvar+i]:=valeur[i];
      nb_fvar:=nb_fvar+nb_valeurs;
      break;
    end;
  end;
  while not eof(nomf) do begin
    readln(nomf,s4,s);
    s4:=uppercase(s4);
    if(s4 = 'FVAR') then begin
      dec(s,valeur,nb_valeurs,ier);
      if (ier > 0)then continue;
      for i:=1 to nb_valeurs do fvar[nb_fvar+i]:=valeur[i];
      nb_fvar:=nb_fvar+nb_valeurs;
      continue;
    end;
    if (s4 ='') or (s4 = 'ANIS') or (s4 = 'AFIX') or (S4 = 'BLOC')
    or (s4 = 'UNDO') or (S4 ='DFIX') then continue;
    if (s4 = 'END')then break;
    if (s4 = 'HKLF')then break;
    if (s4 = 'COND')then break;

    while (pos('0-',s) > 0) do insert(' ',s,pos('-0',s));
    if (pos('=',s) > 0)then begin
      delete(s,pos('=',s),1);
      readln(nomf,s1);
      s:=s+s1;
    end;
    dec(s,valeur,nb_valeurs,ier);
    if (ier > 0)then begin
      erreur('read error');
      nb_atome:=0;
      nom_fichier_cry:='';
      closefile(nomf);
      ier:=1;
      exit;
    end;

//coordonnes
    for i:=1 to 3 do begin
      k:=round(valeur[i+1]);
      if (k > 10)then begin
        m:=k div 10;
        p:=k mod 10;
        valeur[i+1]:=p*fvar[m];
      end;
    end;
    nb_atome:=nb_atome+1;
    if (nb_atome > 100)then begin
      erreur('The number of atoms is > 100!');
      closefile(nomf);
      chdir(repertoire_origine);
      ier:=1;
      exit;
    end;
    x_at[nb_atome]:=valeur[2];
    y_at[nb_atome]:=valeur[3];
    z_at[nb_atome]:=valeur[4];
    pop[nb_atome]:=1;
    s1:=s4;
    traite_nom_element(s1);
    atome[nb_atome]:=copy(s1,1,2);
    labell[nb_atome]:=copy(s1,3,2);

    //agitation thermique
    if (nb_valeurs = 6) then begin
      k:=round(valeur[6]);
      if (k > 10)then begin
        m:=k div 10;
        p:=k mod 10;
        valeur[6]:=p*fvar[m];
      end;
      btherm[nb_atome]:=valeur[6]*huipi2/3 ;
    end else begin
      for i:=1 to 6 do begin
        k:=round(valeur[i+5]);
        if (k > 10)then begin
          m:=k div 10;
          p:=k mod 10;
          valeur[i+5]:=p*fvar[m];
        end;
      end;
      ueq:=0;
      for i:=1 to 6 do ueq:=ueq+valeur[5+i]*t[i]*v[i];
      btherm[nb_atome]:=ueq*huipi2/3;
      (*
      beq:=0;
      for i:=1 to 6 do beq:=beq+valeur[5+i]*u[i];
      btherm[nb_atome]:=beq/3;
      *)
    end;
  end;
  closeFile(nomf);
  chdir(repertoire_origine);
end;

procedure lit_powdercell(var ier:integer);
//----------------------------------------
var
 nomf                           : textfile;
 s5                             : string[5];
 s,ss                           : string;
 valeur                         : tab_dec;
 i,j,nb_valeurs,no_groupe       : integer;
begin
   ier:=1;
   AssignFile(nomf,nom_fichier_cry);
   reset(nomf);
   
//Lecture de la maille
   while not(eof(nomf)) do begin
      readln(nomf,s5,s);s5:=trim(s5);s5:=uppercase(s5);
      if (s5 <> 'CELL')then continue;
      ier:=1;
      for i:=1 to 11 do valeur[i]:=0;
      dec(s,valeur,nb_valeurs,ier);
      nb_atome:=0;
      if(ier = 0) then begin
        for i:=1 to 6 do cel[i]:=valeur[i];
        setmat;
        quel_systeme;
        if (systeme = 'QUAD')then systeme:='TETR' ;
        break;
      end;
   end;
   if (ier = 1)then begin
     erreur('Cell parameters not found!');
     exit;
   end;
   closefile(nomf);

//Lecture des atomes
   i:=0;
   AssignFile(nomf,nom_fichier_cry);
   reset(nomf);
   while not(eof(nomf)) do begin
      readln(nomf,s5,s);s5:=trim(s5);s5:=uppercase(s5);
      if (s5 = '')then continue;
      if (s5 = 'CELL') or (s5 = 'NATOM')then continue;
      if (pos('RGNR',s5) > 0) then break;
      ss:=copy(s5,1,4);
      traite_nom_element(ss);
      i:=i+1;
      atome[i]:=copy(ss,1,2);
      labell[i]:=copy(ss,3,2);
      for j:=1 to 11 do valeur[j]:=0;
      dec(s,valeur,nb_valeurs,ier);
      if (ier > 0)then continue;
      x_at[i]:=valeur[2];
      y_at[i]:=valeur[3];
      z_at[i]:=valeur[4];
      pop[i]:=1;
      btherm[i]:=valeur[5];
   end;
   closefile(nomf);
   nb_atome:=i;
   s:=trim(s);
   val(s,no_groupe,ier);
//Lecture du groupe d'espace
   assignfile(nomf,'csp.lst');
   reset(nomf);
   for j:=1 to no_groupe-1 do readln(nomf);
   readln(nomf,j,s);
   groupe_espace:=copy(s,1,10);
   groupe_espace:=trim(groupe_espace);
   closefile(nomf);
   chdir(repertoire_origine);
end;

procedure lit_icsd(var ier:integer);
//------------------------------------
var
   nomf                            : TextFile;
   i,j                             : integer;
   s,s1                            : string;
   c4                              : string[4];
   tableau                         : tab_dec;
begin
   ier:=0;
   AssignFile(nomf,nom_fichier_cry);
   reset(nomf);
   while not(eof(nomf)) do begin
      readln(nomf,c4,s);

      //dcodage titre
      if (c4 = 'TITL')then begin
         titre:=s;
         continue;
      end;

      //Dcodage paramtres
      c4:=trim(c4);
      s:=trim(s);
      if (c4 = 'CELL')then begin
        for i:=1 to 6 do begin
          j:=pos('=',s);
          delete(s,j-1,2);
        end;
        while (pos('(',s) > 0)do begin
          i:=pos('(',s);
          j:=pos(')',s);
          delete(s,i,j-i+1);
        end;
        j:=6;
        dec(s,tableau,j,ier);
        if (ier = 0)then begin
          for i:=1 to 6 do cel[i]:=tableau[i];
          quel_systeme;
          end else begin
            erreur('Cell parameters not found!');
            closeFile(nomf);
            ier:=1;
            exit;
          end;
      end;

      //Dcodage groupe d'espace
      if (c4 = 'SGR')then begin
        i:=pos('(',s);
        s1:=copy(s,1,i-1);
        s1:=trim(s1);
        groupe_espace:='';
        while (pos(' ',s1) > 0) do delete(s1,pos(' ',s1),1);
        if (s1[length(s1)] = 'H')then delete (s1,length(s1),1);
        groupe_espace:=s1;
        break;
      end;
   end;
   closefile(nomf);
end;


procedure lit_lazyPulverix(var ier:integer);
//------------------------------------------

var
  i,j                 : integer;
  nomf                : TextFile;
  s                   : string[80];
  valeurs             : tab_dec;
begin
   ier:=0;
   AssignFile(nomf,nom_fichier_cry);
   reset(nomf);
   nb_atome:=0;
   while not(eof(nomf)) do begin
      readln(nomf,s);
      if (pos('TITLE',s) > 0)then begin
        delete(s,1,pos(' ',s));
        titre:=s;
      end;
      if (pos('CELL',s) > 0)then begin
        delete(s,1,pos(' ',s));
        dec(s,valeurs,j,ier);
        if (ier = 0)then begin
          for i:=1 to 6 do cel[i]:=valeurs[i];
          setmat;
          quel_systeme;
          if (systeme = 'QUAD')then systeme:='TETR' ;
        end else begin
          erreur('Cell not found');
          closefile(nomf);
          ier:=1;
          exit;
        end;
      end;
      if (pos('SPCGRP',s) > 0)then begin
        delete(s,1,pos(' ',s));
        while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
        groupe_espace:=s;
      end;
      if (pos('ATOM',s) > 0)then begin
        nb_atome:=nb_atome+1;
        if (nb_atome > 100)then begin
          erreur('The number of atoms is > 100!');
          closefile(nomf);
          chdir(repertoire_origine);
          ier:=1;
          exit;
        end;
        delete(s,1,pos('ATOM',s)+4);
        s:=trim(s);
        atome[nb_atome]:=copy(s,1,2);
        labell[nb_atome]:=copy(s,4,2);
        delete(s,1,5);
        dec(s,valeurs,i,ier);
        if (ier > 0)then begin
          erreur('Read error');
          closefile(nomf);
          ier:=1;
          exit;
        end;
        x_at[nb_atome]:=valeurs[1];
        y_at[nb_atome]:=valeurs[2];
        z_at[nb_atome]:=valeurs[3];
        pop[nb_atome]:=valeurs[4];
        btherm[nb_atome]:=valeurs[5];
      end;
   end;
   closefile(nomf);
   chdir(repertoire_origine);
end;
end.
