unit print;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, printers, math, Buttons;


type
  Tfprint = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    PrintDialog1: TPrintDialog;
    procedure sortie(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fprint: Tfprint;

//Procedure Go_impression;

implementation

{$R *.DFM}


uses
  mathhkl, main;

var
  echx,echy,t1,t2                                    : single;
  ix0,iy0                                            : integer;
  xcm,ycm,bordx_cm,bordy_cm ,largeur_cm,hauteur_cm   : single;
  commentaire                                        : string;

procedure sujtopx(xsuj,ysuj:single; var px,py:integer);{
-------------------------------------------------------}
begin
     xcm:=bordx_cm+(xsuj-t1)*echx;
     ycm:=bordy_cm+(ysuj-ymin)*echy;
     px:=trunc(xcm*117.66);
     py:=iy0-trunc(ycm*117.66);
end;

procedure trasI(x,y: single; i :integer);{
----------------------------------------}
var
  ix,iy  : integer;
begin
  sujtopx(x,y,ix,iy);
  if (i = 1)then Printer.canvas.lineto(ix,iy);
  if (i = 0)then Printer.canvas.moveto(ix,iy);
end;

{Trac de l'axe des X}
procedure axex(x1,y1,x2:single);{
--------------------------------}
var
  d,dx,x                                  : single;
  ix,iy,i                          : integer;
  s                                       : string;
  label lab1;
begin
  {Espacement des graduations}
  d:=10;
  dx:=abs(x2-x1);
  if(dx < 0.1)                then d:=0.01;
  if(dx > 0.5) and (dx <= 1)  then d:=0.1;
  if(dx > 1)   and (dx <= 10) then d:=1;
  if(dx > 10)  and (dx <= 50) then d:=5;
  if(dx > 50)  and (dx <= 100)then d:=10;
  if(dx > 100)                then d:=20;

{Trac des graduations}
   trasI(x1,y1,0);
   trasI(x2,y1,1);
   i:=round(x1/d);
   dx:=i;
   x:=dx*d;
   if (x < x1) then x:=x+d;
   while (x <= x2) do begin
     trasI(x,y1,0);
     {Quadrillage}
     sujtopx(x,y1,ix,iy);
     Printer.canvas.moveto(ix,iy);
     //sujtopx(x,y1-(ymax-y1)/40,ii,jj);
     Printer.canvas.lineto(ix,iy+20);
     {Si x est suprieur  100, on change de format}
     if (x >= 100) then begin
        str(x:5:1,s);
     end else begin
        str(x:5:2,s);
     end;
     Printer.canvas.textout(ix-40,iy+30,s);
     x:=x+d;
   end;
end;

{Trac de l'axe des Y}
Procedure axey(x1,y1,y2:single);{
--------------------------------}
var
  d2,d,dy,y                           : single;
  i,j,ix,iy                           : integer;
  s                                   : string;
begin
  {Espacement des graduations}
  d2:=y2-y1;
  d:=1000000;
  if (d2 < 2000000) then d:=100000;
  if (d2 < 200000 ) then d:=10000;
  if (d2 < 20000  ) then d:=1000;
  if (d2 < 2000   ) then d:=100;
  if (d2 < 200    ) then d:=10;
  if (d2 < 20     ) then d:=1;
  {Trac des graduations}
  d:=2*d;
  trasI(x1,y1,0);
  trasI(x1,y2,1);
  i:= round(y1/d);
  dy:=i;
  y:=dy*d;
  if (y < y1) then y:=y+d;
  while (y <= y2) do begin
    trasI(x1,y,0);
    sujtopx(x1,y,ix,iy);
    {Quadrillage}
    sujtopx(t2,y,i,j);
    i:=round(y);
    str(i:5,s);
    y:=y+d;
  end;
end;

Procedure Go_impression;{
------------------------}
var
   i,j,ix,iy,n, iyw                 : integer;
   s,s1                             : string;
   xx,ech_pro                       : double;
   yy                               : tab_single10000;
const
  couleur:array[1..10]of integer=(clred,clblue,clfuchsia,clmaroon,clnavy,
  clgreen,clpurple,clolive,cllime,claqua);
begin

  case fmain.RadioGroup1.ItemIndex of
     0: begin
         t1:=theta_min/2;
         t2:=theta_max/2;
       end;
    1: begin
         t1:=theta_min;
         t2:=theta_max;
       end;
    2: begin
         t1:=q_min;
         t2:=q_max;
       end;
  end;
   Screen.Cursor:=CrHourGlass;
   if (nb_pro > 0)then begin
     ymin:=0;
     ymax:=0;
     for i:=2 to nb_pro do begin
       if (ymax < y_pro[i]) then ymax:=y_pro[i];
     end;
   end;

   bordx_cm:=2;                           {bords en cm}
   bordy_cm:=1.5;
   hauteur_cm:=21-2*bordy_cm;             {dimensions de l'image en cm}
   largeur_cm:=29-2*bordx_cm;
   ix0:=round(bordx_cm*117.66);           {coord. pixels de l'origine des axes}
   iy0:=round(21*117.66-bordy_cm*117.66);
   echx:=largeur_cm/(t2-t1);{nb de cm par unit sujet}
   ymax:=ymax;
   ymin:=ymin;
   echy:=hauteur_cm*facteur_echelle/(ymax-ymin);

   Printer.Orientation:=PoLandscape;
   printer.canvas.pen.color:=clblack;
   printer.canvas.font.name:='Arial';
   printer.canvas.font.size:=8;
   Printer.Canvas.Pen.Width :=2;
   Printer.BeginDoc;

   // Ecritures diverses
   titre:=trimleft(titre);
   printer.canvas.textout(0,2250,'Title: '+Titre);
   sujtopx(0.5*(t2+t1),0,ix,iy);
   printer.canvas.textout(ix-400,0,'POUDRIX. Powder diagram simulation');
   printer.canvas.textout(0,2200,commentaire);
   str(cel[1]:7:3,s);
   printer.canvas.textout(1200,2200,'a='+s);
   str(cel[2]:7:3,s);
   printer.canvas.textout(1200,2250,'b='+s);
   str(cel[3]:7:3,s);
   printer.canvas.textout(1200,2300,'c='+s);
   str(cel[4]:7:2,s);
   printer.canvas.textout(1400,2200,'alpha='+s);
   str(cel[5]:7:2,s);
   printer.canvas.textout(1400,2250,'beta ='+s);
   str(cel[6]:7:2,s);
   printer.canvas.textout(1400,2300,'gamma='+s);
   printer.canvas.textout(1700,2200,'Sp. Group: '+groupe_espace);
   str(lambda:9:5,s);
   printer.canvas.textout(1700,2250,'Lambda='+s);
   case fmain.RadioGroup1.ItemIndex of
     0: printer.canvas.textout(26*118,2200,'Theta');
     1: printer.canvas.textout(26*118,2200,'2Theta');
     2: printer.canvas.textout(26*118,2200,'4Pi.sin(Theta/lambda)');
   end;

   {Trac des axes}
   axex(t1,0,t2);
   axey(t1,0,ymax/facteur_echelle);

   {trac du cadre}
   trasI(t1,ymin,0);
   trasI(t2,ymin,1);
   trasI(t2,ymax/facteur_echelle,1);
   trasI(t1,ymax/facteur_echelle,1);
   trasI(t1,ymin,0);
   Printer.Canvas.Pen.Width :=3;

   //Ecriture echelle Y
   case type_echelle of
     0: s:='Intensity';
     1: s:='Log(Intensity)';
     2: S:='SQRT(Intensity)';
   end;
   printer.canvas.textout(20,0,s);
   iyw:=100;
   str(wl_impur[1]:8:5,s);
   if (nb_pro > 0)then printer.canvas.textout(20,iyw,'As calculated ('+s+')');

   //Trac du diagramme calcul
   if (fmain.radiogroup1.ItemIndex <> 2)then begin
    if (type_echelle = 0)then begin                  //Mise  l'chelle des Y
      for i:=1 to nb_pro do yy[i]:=y_pro[i];
    end else if (type_echelle = 1) then begin
      ech_pro:=100/log10(101);
      for i:=1 to nb_pro do  yy[i]:=log10(y_pro[i]+1)*ech_pro;
    end else if (type_echelle = 2) then begin
      ech_pro:=100/sqrt(101);
      for i:=1 to nb_pro do yy[i]:=sqrt(y_pro[i])*ech_pro;
    end;
  end else begin   //reprsentation en Q
    for i:=1 to nb_raie do  yy[i]:=q_tot[i].int*100/qint_max ;
    if (type_echelle = 1) then begin
      ech_pro:=100/log10(101);
      for i:=1 to nb_raie do  yy[i]:=log10(yy[i])*ech_pro;
    end else if (type_echelle = 2) then begin
      ech_pro:=100/sqrt(101);
      for i:=1 to nb_raie do yy[i]:=sqrt(yy[i])*ech_pro;
    end;
  end;
  case fmain.RadioGroup1.ItemIndex of
      0: begin
           n:=0;
           for i:=2 to nb_pro do begin
             xx:=0.5*x_pro[i];
             if (xx < t1)then continue;
             if (xx > t2)then break;
             n:=n+1;
             if (n = 1)then trasi(xx,yy[i],0) else trasi(xx,yy[i],1);
           end;
         end;
      1: begin
           n:=0;
           for i:=2 to nb_pro do begin
             xx:=x_pro[i];
             if (xx < t1)then continue;
             if (xx > t2)then break;
             n:=n+1;
             if (n = 1)then trasi(xx,yy[i],0) else trasi(xx,yy[i],1);
           end;
         end;
      2: begin
           printer.canvas.pen.width:=7;
           for i:=1 to nb_raie do begin
             xx:=q_tot[i].q;
             if (xx < t1)then continue;
             if (xx > t2) then break;
             trasi(xx,0,0);
             trasi(xx,yy[i],1)
           end;
           printer.canvas.pen.width:=2;
         end;
  end;
  printer.canvas.pen.color:=clblack;

   //Trac des diagrammes RAW
   //printer.canvas.pen.style:=pssolid;
   if (nbraw_pro > 0)then begin
      for j:=1 to nbraw_pro do begin
        iyw:=iyw+70;

        printer.canvas.font.color:=couleur[j];
        s:=extractFilename(nom_raw[j]);
        str(lambda_fichier_raw[j]:8:5,s1);
        s1:=' ('+s1+' )';
        s:=s+s1;
        printer.canvas.textout(20,iyw,s);
        printer.canvas.font.color:=clblack;

        for i:=1 to 1015 do begin
          case type_echelle of
            0: yy[i]:=yraw_pro[j,i];
            1: yy[i]:=log10(yraw_pro[j,i]+1);
            2: yy[i]:=sqrt(yraw_pro[j,i]);
          end;
        end;
        ymax:=0;
        for i:=1 to 1015 do  if (yy[i] > ymax)then ymax:=yy[i];
        ech_pro:=100/ymax;
        for i:=1 to 1015 do yy[i]:=yy[i]*ech_pro;
        n:=0;
        printer.canvas.pen.color:=couleur[j];
        echy:=hauteur_cm*facteur_echelle/(ymax*ech_pro);
        for i:=1 to 1015 do begin
          if (xraw_pro[j,i] < theta_min) or (xraw_pro[j,i] > theta_max)then continue;
          case fmain.RadioGroup1.ItemIndex of
            1: xx:=xraw_pro[j,i];
            0: xx:=0.5*xraw_pro[j,i];
            2: xx:=qraw_pro[j,i];
          end;
          if (n = 0)then trasi(xx,yy[i],0) else trasi(xx,yy[i],1);
          n:=n+1;
        end;
      end;
   end;
   Printer.EndDoc;
   Screen.Cursor:=CrDefault;
   fprint.close;
end;

procedure Tfprint.sortie(Sender: TObject);
//----------------------------------------
begin
  if PrintDialog1.execute then begin
    commentaire:=edit1.text;
    go_impression;
  end;
end;

end.
